/* arena.c generated by valac 0.56.17, the Vala compiler
 * generated from arena.vala, do not modify */

/*
 * Copyright 2020 Andrey Kutejko <andy128k@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 * For more details see the file COPYING.
 */

#include <glib-object.h>
#include <glib.h>
#include <gee.h>
#include <string.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	OBJECT_TYPE_PLAYER = 0,
	OBJECT_TYPE_HEAP = 1,
	OBJECT_TYPE_ROBOT1 = 2,
	OBJECT_TYPE_ROBOT2 = 3,
	OBJECT_TYPE_NONE = 99
} ObjectType;

#define TYPE_OBJECT_TYPE (object_type_get_type ())
typedef ObjectType (*ArenaMapper) (ObjectType obj, gpointer user_data);

#define TYPE_ARENA (arena_get_type ())
#define ARENA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ARENA, Arena))
#define ARENA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ARENA, ArenaClass))
#define IS_ARENA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ARENA))
#define IS_ARENA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ARENA))
#define ARENA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ARENA, ArenaClass))

typedef struct _Arena Arena;
typedef struct _ArenaClass ArenaClass;
typedef struct _ArenaPrivate ArenaPrivate;

#define ARENA_TYPE_COORDS (arena_coords_get_type ())
typedef struct _ArenaCoords ArenaCoords;

#define TYPE_ARENA_ITERABLE (arena_iterable_get_type ())
#define ARENA_ITERABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ARENA_ITERABLE, ArenaIterable))
#define ARENA_ITERABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ARENA_ITERABLE, ArenaIterableClass))
#define IS_ARENA_ITERABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ARENA_ITERABLE))
#define IS_ARENA_ITERABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ARENA_ITERABLE))
#define ARENA_ITERABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ARENA_ITERABLE, ArenaIterableClass))

typedef struct _ArenaIterable ArenaIterable;
typedef struct _ArenaIterableClass ArenaIterableClass;
typedef struct _ParamSpecArena ParamSpecArena;
typedef struct _ArenaIterablePrivate ArenaIterablePrivate;
#define _arena_unref0(var) ((var == NULL) ? NULL : (var = (arena_unref (var), NULL)))

#define ARENA_ITERABLE_TYPE_ITERATOR (arena_iterable_iterator_get_type ())
#define ARENA_ITERABLE_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ARENA_ITERABLE_TYPE_ITERATOR, ArenaIterableIterator))
#define ARENA_ITERABLE_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ARENA_ITERABLE_TYPE_ITERATOR, ArenaIterableIteratorClass))
#define ARENA_ITERABLE_IS_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ARENA_ITERABLE_TYPE_ITERATOR))
#define ARENA_ITERABLE_IS_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ARENA_ITERABLE_TYPE_ITERATOR))
#define ARENA_ITERABLE_ITERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ARENA_ITERABLE_TYPE_ITERATOR, ArenaIterableIteratorClass))

typedef struct _ArenaIterableIterator ArenaIterableIterator;
typedef struct _ArenaIterableIteratorClass ArenaIterableIteratorClass;
typedef struct _ArenaIterableIteratorPrivate ArenaIterableIteratorPrivate;
typedef struct _ArenaIterableParamSpecIterator ArenaIterableParamSpecIterator;
typedef struct _ParamSpecArenaIterable ParamSpecArenaIterable;

struct _Arena {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ArenaPrivate * priv;
};

struct _ArenaClass {
	GTypeClass parent_class;
	void (*finalize) (Arena *self);
};

struct _ArenaPrivate {
	gint _width;
	gint _height;
	ObjectType* arena;
	gint arena_length1;
	gint _arena_size_;
};

struct _ArenaCoords {
	gint x;
	gint y;
};

struct _ParamSpecArena {
	GParamSpec parent_instance;
};

struct _ArenaIterable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ArenaIterablePrivate * priv;
};

struct _ArenaIterableClass {
	GTypeClass parent_class;
	void (*finalize) (ArenaIterable *self);
};

struct _ArenaIterablePrivate {
	Arena* arena;
	gint initial_x;
	gint initial_y;
};

struct _ArenaIterableIterator {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ArenaIterableIteratorPrivate * priv;
};

struct _ArenaIterableIteratorClass {
	GTypeClass parent_class;
	void (*finalize) (ArenaIterableIterator *self);
};

struct _ArenaIterableIteratorPrivate {
	gint initial_position;
	gint width;
	gint size;
	gint i;
};

struct _ArenaIterableParamSpecIterator {
	GParamSpec parent_instance;
};

struct _ParamSpecArenaIterable {
	GParamSpec parent_instance;
};

static gint Arena_private_offset;
static gpointer arena_parent_class = NULL;
static gint ArenaIterable_private_offset;
static gpointer arena_iterable_parent_class = NULL;
static gint ArenaIterableIterator_private_offset;
static gpointer arena_iterable_iterator_parent_class = NULL;

VALA_EXTERN GType object_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gpointer arena_ref (gpointer instance);
VALA_EXTERN void arena_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_arena (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags);
VALA_EXTERN void value_set_arena (GValue* value,
                      gpointer v_object);
VALA_EXTERN void value_take_arena (GValue* value,
                       gpointer v_object);
VALA_EXTERN gpointer value_get_arena (const GValue* value);
VALA_EXTERN GType arena_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Arena, arena_unref)
VALA_EXTERN Arena* arena_new (gint width,
                  gint height);
VALA_EXTERN Arena* arena_construct (GType object_type,
                        gint width,
                        gint height);
VALA_EXTERN void arena_clear (Arena* self);
VALA_EXTERN GType arena_coords_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ArenaCoords* arena_coords_dup (const ArenaCoords* self);
VALA_EXTERN void arena_coords_free (ArenaCoords* self);
VALA_EXTERN gboolean arena_are_coords_valid (Arena* self,
                                 ArenaCoords* coords);
VALA_EXTERN ObjectType arena_get (Arena* self,
                      gint x,
                      gint y);
VALA_EXTERN void arena_set (Arena* self,
                gint x,
                gint y,
                ObjectType obj);
VALA_EXTERN Arena* arena_map (Arena* self,
                  ArenaMapper mapper,
                  gpointer mapper_target);
VALA_EXTERN gint arena_count (Arena* self,
                  GeePredicate predicate,
                  gpointer predicate_target);
VALA_EXTERN gpointer arena_iterable_ref (gpointer instance);
VALA_EXTERN void arena_iterable_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_arena_iterable (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
VALA_EXTERN void value_set_arena_iterable (GValue* value,
                               gpointer v_object);
VALA_EXTERN void value_take_arena_iterable (GValue* value,
                                gpointer v_object);
VALA_EXTERN gpointer value_get_arena_iterable (const GValue* value);
VALA_EXTERN GType arena_iterable_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ArenaIterable, arena_iterable_unref)
VALA_EXTERN ArenaIterable* arena_iterate_from (Arena* self,
                                   gint x,
                                   gint y);
VALA_EXTERN ArenaIterable* arena_iterable_new (Arena* arena,
                                   gint initial_x,
                                   gint initial_y);
VALA_EXTERN ArenaIterable* arena_iterable_construct (GType object_type,
                                         Arena* arena,
                                         gint initial_x,
                                         gint initial_y);
VALA_EXTERN gint arena_get_width (Arena* self);
VALA_EXTERN gint arena_get_height (Arena* self);
VALA_EXTERN void arena_coords_move (ArenaCoords *self,
                        gint dx,
                        gint dy,
                        ArenaCoords* result);
static void arena_finalize (Arena * obj);
static GType arena_get_type_once (void);
VALA_EXTERN gpointer arena_iterable_iterator_ref (gpointer instance);
VALA_EXTERN void arena_iterable_iterator_unref (gpointer instance);
VALA_EXTERN GParamSpec* arena_iterable_param_spec_iterator (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags);
VALA_EXTERN void arena_iterable_value_set_iterator (GValue* value,
                                        gpointer v_object);
VALA_EXTERN void arena_iterable_value_take_iterator (GValue* value,
                                         gpointer v_object);
VALA_EXTERN gpointer arena_iterable_value_get_iterator (const GValue* value);
VALA_EXTERN GType arena_iterable_iterator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ArenaIterableIterator, arena_iterable_iterator_unref)
VALA_EXTERN ArenaIterableIterator* arena_iterable_iterator (ArenaIterable* self);
VALA_EXTERN ArenaIterableIterator* arena_iterable_iterator_new (ArenaIterable* iterable);
VALA_EXTERN ArenaIterableIterator* arena_iterable_iterator_construct (GType object_type,
                                                          ArenaIterable* iterable);
VALA_EXTERN ArenaCoords* arena_iterable_iterator_next_value (ArenaIterableIterator* self);
static void arena_iterable_iterator_finalize (ArenaIterableIterator * obj);
static GType arena_iterable_iterator_get_type_once (void);
static void arena_iterable_finalize (ArenaIterable * obj);
static GType arena_iterable_get_type_once (void);

static GType
object_type_get_type_once (void)
{
	static const GEnumValue values[] = {{OBJECT_TYPE_PLAYER, "OBJECT_TYPE_PLAYER", "player"}, {OBJECT_TYPE_HEAP, "OBJECT_TYPE_HEAP", "heap"}, {OBJECT_TYPE_ROBOT1, "OBJECT_TYPE_ROBOT1", "robot1"}, {OBJECT_TYPE_ROBOT2, "OBJECT_TYPE_ROBOT2", "robot2"}, {OBJECT_TYPE_NONE, "OBJECT_TYPE_NONE", "none"}, {0, NULL, NULL}};
	GType object_type_type_id;
	object_type_type_id = g_enum_register_static ("ObjectType", values);
	return object_type_type_id;
}

GType
object_type_get_type (void)
{
	static volatile gsize object_type_type_id__once = 0;
	if (g_once_init_enter (&object_type_type_id__once)) {
		GType object_type_type_id;
		object_type_type_id = object_type_get_type_once ();
		g_once_init_leave (&object_type_type_id__once, object_type_type_id);
	}
	return object_type_type_id__once;
}

static inline gpointer
arena_get_instance_private (Arena* self)
{
	return G_STRUCT_MEMBER_P (self, Arena_private_offset);
}

Arena*
arena_construct (GType object_type,
                 gint width,
                 gint height)
{
	Arena* self = NULL;
	ObjectType* _tmp0_;
#line 56 "../src/arena.vala"
	self = (Arena*) g_type_create_instance (object_type);
#line 57 "../src/arena.vala"
	self->priv->_width = width;
#line 58 "../src/arena.vala"
	self->priv->_height = height;
#line 59 "../src/arena.vala"
	_tmp0_ = g_new0 (ObjectType, width * height);
#line 59 "../src/arena.vala"
	self->priv->arena = (g_free (self->priv->arena), NULL);
#line 59 "../src/arena.vala"
	self->priv->arena = _tmp0_;
#line 59 "../src/arena.vala"
	self->priv->arena_length1 = width * height;
#line 59 "../src/arena.vala"
	self->priv->_arena_size_ = self->priv->arena_length1;
#line 60 "../src/arena.vala"
	arena_clear (self);
#line 56 "../src/arena.vala"
	return self;
#line 326 "arena.c"
}

Arena*
arena_new (gint width,
           gint height)
{
#line 56 "../src/arena.vala"
	return arena_construct (TYPE_ARENA, width, height);
#line 335 "arena.c"
}

void
arena_clear (Arena* self)
{
#line 63 "../src/arena.vala"
	g_return_if_fail (self != NULL);
#line 343 "arena.c"
	{
		gint i = 0;
#line 64 "../src/arena.vala"
		i = 0;
#line 348 "arena.c"
		{
			gboolean _tmp0_ = FALSE;
#line 64 "../src/arena.vala"
			_tmp0_ = TRUE;
#line 64 "../src/arena.vala"
			while (TRUE) {
#line 64 "../src/arena.vala"
				if (!_tmp0_) {
#line 357 "arena.c"
					gint _tmp1_;
#line 64 "../src/arena.vala"
					i = i + 1;
#line 64 "../src/arena.vala"
					_tmp1_ = i;
#line 363 "arena.c"
				}
#line 64 "../src/arena.vala"
				_tmp0_ = FALSE;
#line 64 "../src/arena.vala"
				if (!(i < self->priv->_width)) {
#line 64 "../src/arena.vala"
					break;
#line 371 "arena.c"
				}
				{
					gint j = 0;
#line 65 "../src/arena.vala"
					j = 0;
#line 377 "arena.c"
					{
						gboolean _tmp2_ = FALSE;
#line 65 "../src/arena.vala"
						_tmp2_ = TRUE;
#line 65 "../src/arena.vala"
						while (TRUE) {
#line 384 "arena.c"
							ObjectType* _tmp4_;
							gint _tmp4__length1;
#line 65 "../src/arena.vala"
							if (!_tmp2_) {
#line 389 "arena.c"
								gint _tmp3_;
#line 65 "../src/arena.vala"
								j = j + 1;
#line 65 "../src/arena.vala"
								_tmp3_ = j;
#line 395 "arena.c"
							}
#line 65 "../src/arena.vala"
							_tmp2_ = FALSE;
#line 65 "../src/arena.vala"
							if (!(j < self->priv->_height)) {
#line 65 "../src/arena.vala"
								break;
#line 403 "arena.c"
							}
#line 66 "../src/arena.vala"
							_tmp4_ = self->priv->arena;
#line 66 "../src/arena.vala"
							_tmp4__length1 = self->priv->arena_length1;
#line 66 "../src/arena.vala"
							_tmp4_[i + (j * self->priv->_width)] = OBJECT_TYPE_NONE;
#line 411 "arena.c"
						}
					}
				}
			}
		}
	}
}

gboolean
arena_are_coords_valid (Arena* self,
                        ArenaCoords* coords)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	ArenaCoords _tmp3_;
	gboolean result;
#line 71 "../src/arena.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 71 "../src/arena.vala"
	g_return_val_if_fail (coords != NULL, FALSE);
#line 72 "../src/arena.vala"
	_tmp3_ = *coords;
#line 72 "../src/arena.vala"
	if (_tmp3_.x >= 0) {
#line 437 "arena.c"
		ArenaCoords _tmp4_;
#line 73 "../src/arena.vala"
		_tmp4_ = *coords;
#line 73 "../src/arena.vala"
		_tmp2_ = _tmp4_.y >= 0;
#line 443 "arena.c"
	} else {
#line 72 "../src/arena.vala"
		_tmp2_ = FALSE;
#line 447 "arena.c"
	}
#line 72 "../src/arena.vala"
	if (_tmp2_) {
#line 451 "arena.c"
		ArenaCoords _tmp5_;
#line 74 "../src/arena.vala"
		_tmp5_ = *coords;
#line 74 "../src/arena.vala"
		_tmp1_ = _tmp5_.x < self->priv->_width;
#line 457 "arena.c"
	} else {
#line 72 "../src/arena.vala"
		_tmp1_ = FALSE;
#line 461 "arena.c"
	}
#line 72 "../src/arena.vala"
	if (_tmp1_) {
#line 465 "arena.c"
		ArenaCoords _tmp6_;
#line 75 "../src/arena.vala"
		_tmp6_ = *coords;
#line 75 "../src/arena.vala"
		_tmp0_ = _tmp6_.y < self->priv->_height;
#line 471 "arena.c"
	} else {
#line 72 "../src/arena.vala"
		_tmp0_ = FALSE;
#line 475 "arena.c"
	}
#line 72 "../src/arena.vala"
	result = _tmp0_;
#line 72 "../src/arena.vala"
	return result;
#line 481 "arena.c"
}

ObjectType
arena_get (Arena* self,
           gint x,
           gint y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	ObjectType* _tmp3_;
	gint _tmp3__length1;
	ObjectType _tmp4_;
	ObjectType result;
#line 78 "../src/arena.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 79 "../src/arena.vala"
	if (x < 0) {
#line 79 "../src/arena.vala"
		_tmp2_ = TRUE;
#line 502 "arena.c"
	} else {
#line 79 "../src/arena.vala"
		_tmp2_ = y < 0;
#line 506 "arena.c"
	}
#line 79 "../src/arena.vala"
	if (_tmp2_) {
#line 79 "../src/arena.vala"
		_tmp1_ = TRUE;
#line 512 "arena.c"
	} else {
#line 79 "../src/arena.vala"
		_tmp1_ = x >= self->priv->_width;
#line 516 "arena.c"
	}
#line 79 "../src/arena.vala"
	if (_tmp1_) {
#line 79 "../src/arena.vala"
		_tmp0_ = TRUE;
#line 522 "arena.c"
	} else {
#line 79 "../src/arena.vala"
		_tmp0_ = y >= self->priv->_height;
#line 526 "arena.c"
	}
#line 79 "../src/arena.vala"
	if (_tmp0_) {
#line 80 "../src/arena.vala"
		result = OBJECT_TYPE_NONE;
#line 80 "../src/arena.vala"
		return result;
#line 534 "arena.c"
	}
#line 82 "../src/arena.vala"
	_tmp3_ = self->priv->arena;
#line 82 "../src/arena.vala"
	_tmp3__length1 = self->priv->arena_length1;
#line 82 "../src/arena.vala"
	_tmp4_ = _tmp3_[x + (y * self->priv->_width)];
#line 82 "../src/arena.vala"
	result = _tmp4_;
#line 82 "../src/arena.vala"
	return result;
#line 546 "arena.c"
}

void
arena_set (Arena* self,
           gint x,
           gint y,
           ObjectType obj)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	ObjectType* _tmp3_;
	gint _tmp3__length1;
#line 85 "../src/arena.vala"
	g_return_if_fail (self != NULL);
#line 86 "../src/arena.vala"
	if (x < 0) {
#line 86 "../src/arena.vala"
		_tmp2_ = TRUE;
#line 566 "arena.c"
	} else {
#line 86 "../src/arena.vala"
		_tmp2_ = y < 0;
#line 570 "arena.c"
	}
#line 86 "../src/arena.vala"
	if (_tmp2_) {
#line 86 "../src/arena.vala"
		_tmp1_ = TRUE;
#line 576 "arena.c"
	} else {
#line 86 "../src/arena.vala"
		_tmp1_ = x >= self->priv->_width;
#line 580 "arena.c"
	}
#line 86 "../src/arena.vala"
	if (_tmp1_) {
#line 86 "../src/arena.vala"
		_tmp0_ = TRUE;
#line 586 "arena.c"
	} else {
#line 86 "../src/arena.vala"
		_tmp0_ = y >= self->priv->_height;
#line 590 "arena.c"
	}
#line 86 "../src/arena.vala"
	if (_tmp0_) {
#line 87 "../src/arena.vala"
		return;
#line 596 "arena.c"
	}
#line 89 "../src/arena.vala"
	_tmp3_ = self->priv->arena;
#line 89 "../src/arena.vala"
	_tmp3__length1 = self->priv->arena_length1;
#line 89 "../src/arena.vala"
	_tmp3_[x + (y * self->priv->_width)] = obj;
#line 604 "arena.c"
}

Arena*
arena_map (Arena* self,
           ArenaMapper mapper,
           gpointer mapper_target)
{
	Arena* new_arena = NULL;
	Arena* _tmp0_;
	Arena* result;
#line 92 "../src/arena.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 93 "../src/arena.vala"
	_tmp0_ = arena_new (self->priv->_width, self->priv->_height);
#line 93 "../src/arena.vala"
	new_arena = _tmp0_;
#line 621 "arena.c"
	{
		gint i = 0;
#line 95 "../src/arena.vala"
		i = 0;
#line 626 "arena.c"
		{
			gboolean _tmp1_ = FALSE;
#line 95 "../src/arena.vala"
			_tmp1_ = TRUE;
#line 95 "../src/arena.vala"
			while (TRUE) {
#line 95 "../src/arena.vala"
				if (!_tmp1_) {
#line 635 "arena.c"
					gint _tmp2_;
#line 95 "../src/arena.vala"
					i = i + 1;
#line 95 "../src/arena.vala"
					_tmp2_ = i;
#line 641 "arena.c"
				}
#line 95 "../src/arena.vala"
				_tmp1_ = FALSE;
#line 95 "../src/arena.vala"
				if (!(i < self->priv->_width)) {
#line 95 "../src/arena.vala"
					break;
#line 649 "arena.c"
				}
				{
					gint j = 0;
#line 96 "../src/arena.vala"
					j = 0;
#line 655 "arena.c"
					{
						gboolean _tmp3_ = FALSE;
#line 96 "../src/arena.vala"
						_tmp3_ = TRUE;
#line 96 "../src/arena.vala"
						while (TRUE) {
#line 662 "arena.c"
							Arena* _tmp5_;
							ObjectType* _tmp6_;
							gint _tmp6__length1;
							ObjectType* _tmp7_;
							gint _tmp7__length1;
							ObjectType _tmp8_;
#line 96 "../src/arena.vala"
							if (!_tmp3_) {
#line 671 "arena.c"
								gint _tmp4_;
#line 96 "../src/arena.vala"
								j = j + 1;
#line 96 "../src/arena.vala"
								_tmp4_ = j;
#line 677 "arena.c"
							}
#line 96 "../src/arena.vala"
							_tmp3_ = FALSE;
#line 96 "../src/arena.vala"
							if (!(j < self->priv->_height)) {
#line 96 "../src/arena.vala"
								break;
#line 685 "arena.c"
							}
#line 97 "../src/arena.vala"
							_tmp5_ = new_arena;
#line 97 "../src/arena.vala"
							_tmp6_ = _tmp5_->priv->arena;
#line 97 "../src/arena.vala"
							_tmp6__length1 = _tmp5_->priv->arena_length1;
#line 97 "../src/arena.vala"
							_tmp7_ = self->priv->arena;
#line 97 "../src/arena.vala"
							_tmp7__length1 = self->priv->arena_length1;
#line 97 "../src/arena.vala"
							_tmp8_ = _tmp7_[i + (j * self->priv->_width)];
#line 97 "../src/arena.vala"
							_tmp6_[i + (j * self->priv->_width)] = mapper (_tmp8_, mapper_target);
#line 701 "arena.c"
						}
					}
				}
			}
		}
	}
#line 101 "../src/arena.vala"
	result = new_arena;
#line 101 "../src/arena.vala"
	return result;
#line 712 "arena.c"
}

gint
arena_count (Arena* self,
             GeePredicate predicate,
             gpointer predicate_target)
{
	gint _result_ = 0;
	gint result;
#line 104 "../src/arena.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 105 "../src/arena.vala"
	_result_ = 0;
#line 726 "arena.c"
	{
		gint i = 0;
#line 106 "../src/arena.vala"
		i = 0;
#line 731 "arena.c"
		{
			gboolean _tmp0_ = FALSE;
#line 106 "../src/arena.vala"
			_tmp0_ = TRUE;
#line 106 "../src/arena.vala"
			while (TRUE) {
#line 106 "../src/arena.vala"
				if (!_tmp0_) {
#line 740 "arena.c"
					gint _tmp1_;
#line 106 "../src/arena.vala"
					i = i + 1;
#line 106 "../src/arena.vala"
					_tmp1_ = i;
#line 746 "arena.c"
				}
#line 106 "../src/arena.vala"
				_tmp0_ = FALSE;
#line 106 "../src/arena.vala"
				if (!(i < self->priv->_width)) {
#line 106 "../src/arena.vala"
					break;
#line 754 "arena.c"
				}
				{
					gint j = 0;
#line 107 "../src/arena.vala"
					j = 0;
#line 760 "arena.c"
					{
						gboolean _tmp2_ = FALSE;
#line 107 "../src/arena.vala"
						_tmp2_ = TRUE;
#line 107 "../src/arena.vala"
						while (TRUE) {
#line 767 "arena.c"
							ObjectType* _tmp4_;
							gint _tmp4__length1;
							ObjectType _tmp5_;
#line 107 "../src/arena.vala"
							if (!_tmp2_) {
#line 773 "arena.c"
								gint _tmp3_;
#line 107 "../src/arena.vala"
								j = j + 1;
#line 107 "../src/arena.vala"
								_tmp3_ = j;
#line 779 "arena.c"
							}
#line 107 "../src/arena.vala"
							_tmp2_ = FALSE;
#line 107 "../src/arena.vala"
							if (!(j < self->priv->_height)) {
#line 107 "../src/arena.vala"
								break;
#line 787 "arena.c"
							}
#line 108 "../src/arena.vala"
							_tmp4_ = self->priv->arena;
#line 108 "../src/arena.vala"
							_tmp4__length1 = self->priv->arena_length1;
#line 108 "../src/arena.vala"
							_tmp5_ = _tmp4_[i + (j * self->priv->_width)];
#line 108 "../src/arena.vala"
							if (predicate ((gpointer) ((gintptr) _tmp5_), predicate_target)) {
#line 109 "../src/arena.vala"
								_result_ += 1;
#line 799 "arena.c"
							}
						}
					}
				}
			}
		}
	}
#line 113 "../src/arena.vala"
	result = _result_;
#line 113 "../src/arena.vala"
	return result;
#line 811 "arena.c"
}

ArenaIterable*
arena_iterate_from (Arena* self,
                    gint x,
                    gint y)
{
	ArenaIterable* _tmp0_;
	ArenaIterable* result;
#line 116 "../src/arena.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 117 "../src/arena.vala"
	_tmp0_ = arena_iterable_new (self, x, y);
#line 117 "../src/arena.vala"
	result = _tmp0_;
#line 117 "../src/arena.vala"
	return result;
#line 829 "arena.c"
}

gint
arena_get_width (Arena* self)
{
	gint result;
#line 49 "../src/arena.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 49 "../src/arena.vala"
	result = self->priv->_width;
#line 49 "../src/arena.vala"
	return result;
#line 842 "arena.c"
}

gint
arena_get_height (Arena* self)
{
	gint result;
#line 53 "../src/arena.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 53 "../src/arena.vala"
	result = self->priv->_height;
#line 53 "../src/arena.vala"
	return result;
#line 855 "arena.c"
}

void
arena_coords_move (ArenaCoords *self,
                   gint dx,
                   gint dy,
                   ArenaCoords* result)
{
	ArenaCoords _tmp0_ = {0};
#line 37 "../src/arena.vala"
	memset (&_tmp0_, 0, sizeof (ArenaCoords));
#line 37 "../src/arena.vala"
	_tmp0_.x = (*self).x + dx;
#line 37 "../src/arena.vala"
	_tmp0_.y = (*self).y + dy;
#line 37 "../src/arena.vala"
	*result = _tmp0_;
#line 37 "../src/arena.vala"
	return;
#line 875 "arena.c"
}

ArenaCoords*
arena_coords_dup (const ArenaCoords* self)
{
	ArenaCoords* dup;
#line 32 "../src/arena.vala"
	dup = g_new0 (ArenaCoords, 1);
#line 32 "../src/arena.vala"
	memcpy (dup, self, sizeof (ArenaCoords));
#line 32 "../src/arena.vala"
	return dup;
#line 888 "arena.c"
}

void
arena_coords_free (ArenaCoords* self)
{
#line 32 "../src/arena.vala"
	g_free (self);
#line 896 "arena.c"
}

static GType
arena_coords_get_type_once (void)
{
	GType arena_coords_type_id;
	arena_coords_type_id = g_boxed_type_register_static ("ArenaCoords", (GBoxedCopyFunc) arena_coords_dup, (GBoxedFreeFunc) arena_coords_free);
	return arena_coords_type_id;
}

GType
arena_coords_get_type (void)
{
	static volatile gsize arena_coords_type_id__once = 0;
	if (g_once_init_enter (&arena_coords_type_id__once)) {
		GType arena_coords_type_id;
		arena_coords_type_id = arena_coords_get_type_once ();
		g_once_init_leave (&arena_coords_type_id__once, arena_coords_type_id);
	}
	return arena_coords_type_id__once;
}

static void
value_arena_init (GValue* value)
{
#line 30 "../src/arena.vala"
	value->data[0].v_pointer = NULL;
#line 924 "arena.c"
}

static void
value_arena_free_value (GValue* value)
{
#line 30 "../src/arena.vala"
	if (value->data[0].v_pointer) {
#line 30 "../src/arena.vala"
		arena_unref (value->data[0].v_pointer);
#line 934 "arena.c"
	}
}

static void
value_arena_copy_value (const GValue* src_value,
                        GValue* dest_value)
{
#line 30 "../src/arena.vala"
	if (src_value->data[0].v_pointer) {
#line 30 "../src/arena.vala"
		dest_value->data[0].v_pointer = arena_ref (src_value->data[0].v_pointer);
#line 946 "arena.c"
	} else {
#line 30 "../src/arena.vala"
		dest_value->data[0].v_pointer = NULL;
#line 950 "arena.c"
	}
}

static gpointer
value_arena_peek_pointer (const GValue* value)
{
#line 30 "../src/arena.vala"
	return value->data[0].v_pointer;
#line 959 "arena.c"
}

static gchar*
value_arena_collect_value (GValue* value,
                           guint n_collect_values,
                           GTypeCValue* collect_values,
                           guint collect_flags)
{
#line 30 "../src/arena.vala"
	if (collect_values[0].v_pointer) {
#line 970 "arena.c"
		Arena * object;
		object = collect_values[0].v_pointer;
#line 30 "../src/arena.vala"
		if (object->parent_instance.g_class == NULL) {
#line 30 "../src/arena.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 977 "arena.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 30 "../src/arena.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 981 "arena.c"
		}
#line 30 "../src/arena.vala"
		value->data[0].v_pointer = arena_ref (object);
#line 985 "arena.c"
	} else {
#line 30 "../src/arena.vala"
		value->data[0].v_pointer = NULL;
#line 989 "arena.c"
	}
#line 30 "../src/arena.vala"
	return NULL;
#line 993 "arena.c"
}

static gchar*
value_arena_lcopy_value (const GValue* value,
                         guint n_collect_values,
                         GTypeCValue* collect_values,
                         guint collect_flags)
{
	Arena ** object_p;
	object_p = collect_values[0].v_pointer;
#line 30 "../src/arena.vala"
	if (!object_p) {
#line 30 "../src/arena.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1008 "arena.c"
	}
#line 30 "../src/arena.vala"
	if (!value->data[0].v_pointer) {
#line 30 "../src/arena.vala"
		*object_p = NULL;
#line 1014 "arena.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 30 "../src/arena.vala"
		*object_p = value->data[0].v_pointer;
#line 1018 "arena.c"
	} else {
#line 30 "../src/arena.vala"
		*object_p = arena_ref (value->data[0].v_pointer);
#line 1022 "arena.c"
	}
#line 30 "../src/arena.vala"
	return NULL;
#line 1026 "arena.c"
}

GParamSpec*
param_spec_arena (const gchar* name,
                  const gchar* nick,
                  const gchar* blurb,
                  GType object_type,
                  GParamFlags flags)
{
	ParamSpecArena* spec;
#line 30 "../src/arena.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_ARENA), NULL);
#line 30 "../src/arena.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 30 "../src/arena.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 30 "../src/arena.vala"
	return G_PARAM_SPEC (spec);
#line 1045 "arena.c"
}

gpointer
value_get_arena (const GValue* value)
{
#line 30 "../src/arena.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ARENA), NULL);
#line 30 "../src/arena.vala"
	return value->data[0].v_pointer;
#line 1055 "arena.c"
}

void
value_set_arena (GValue* value,
                 gpointer v_object)
{
	Arena * old;
#line 30 "../src/arena.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ARENA));
#line 30 "../src/arena.vala"
	old = value->data[0].v_pointer;
#line 30 "../src/arena.vala"
	if (v_object) {
#line 30 "../src/arena.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ARENA));
#line 30 "../src/arena.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 30 "../src/arena.vala"
		value->data[0].v_pointer = v_object;
#line 30 "../src/arena.vala"
		arena_ref (value->data[0].v_pointer);
#line 1077 "arena.c"
	} else {
#line 30 "../src/arena.vala"
		value->data[0].v_pointer = NULL;
#line 1081 "arena.c"
	}
#line 30 "../src/arena.vala"
	if (old) {
#line 30 "../src/arena.vala"
		arena_unref (old);
#line 1087 "arena.c"
	}
}

void
value_take_arena (GValue* value,
                  gpointer v_object)
{
	Arena * old;
#line 30 "../src/arena.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ARENA));
#line 30 "../src/arena.vala"
	old = value->data[0].v_pointer;
#line 30 "../src/arena.vala"
	if (v_object) {
#line 30 "../src/arena.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ARENA));
#line 30 "../src/arena.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 30 "../src/arena.vala"
		value->data[0].v_pointer = v_object;
#line 1108 "arena.c"
	} else {
#line 30 "../src/arena.vala"
		value->data[0].v_pointer = NULL;
#line 1112 "arena.c"
	}
#line 30 "../src/arena.vala"
	if (old) {
#line 30 "../src/arena.vala"
		arena_unref (old);
#line 1118 "arena.c"
	}
}

static void
arena_class_init (ArenaClass * klass,
                  gpointer klass_data)
{
#line 30 "../src/arena.vala"
	arena_parent_class = g_type_class_peek_parent (klass);
#line 30 "../src/arena.vala"
	((ArenaClass *) klass)->finalize = arena_finalize;
#line 30 "../src/arena.vala"
	g_type_class_adjust_private_offset (klass, &Arena_private_offset);
#line 1132 "arena.c"
}

static void
arena_instance_init (Arena * self,
                     gpointer klass)
{
#line 30 "../src/arena.vala"
	self->priv = arena_get_instance_private (self);
#line 30 "../src/arena.vala"
	self->ref_count = 1;
#line 1143 "arena.c"
}

static void
arena_finalize (Arena * obj)
{
	Arena * self;
#line 30 "../src/arena.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ARENA, Arena);
#line 30 "../src/arena.vala"
	g_signal_handlers_destroy (self);
#line 46 "../src/arena.vala"
	self->priv->arena = (g_free (self->priv->arena), NULL);
#line 1156 "arena.c"
}

static GType
arena_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_arena_init, value_arena_free_value, value_arena_copy_value, value_arena_peek_pointer, "p", value_arena_collect_value, "p", value_arena_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ArenaClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) arena_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Arena), 0, (GInstanceInitFunc) arena_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType arena_type_id;
	arena_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Arena", &g_define_type_info, &g_define_type_fundamental_info, 0);
	Arena_private_offset = g_type_add_instance_private (arena_type_id, sizeof (ArenaPrivate));
	return arena_type_id;
}

GType
arena_get_type (void)
{
	static volatile gsize arena_type_id__once = 0;
	if (g_once_init_enter (&arena_type_id__once)) {
		GType arena_type_id;
		arena_type_id = arena_get_type_once ();
		g_once_init_leave (&arena_type_id__once, arena_type_id);
	}
	return arena_type_id__once;
}

gpointer
arena_ref (gpointer instance)
{
	Arena * self;
	self = instance;
#line 30 "../src/arena.vala"
	g_atomic_int_inc (&self->ref_count);
#line 30 "../src/arena.vala"
	return instance;
#line 1192 "arena.c"
}

void
arena_unref (gpointer instance)
{
	Arena * self;
	self = instance;
#line 30 "../src/arena.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 30 "../src/arena.vala"
		ARENA_GET_CLASS (self)->finalize (self);
#line 30 "../src/arena.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1206 "arena.c"
	}
}

static inline gpointer
arena_iterable_get_instance_private (ArenaIterable* self)
{
	return G_STRUCT_MEMBER_P (self, ArenaIterable_private_offset);
}

static gpointer
_arena_ref0 (gpointer self)
{
#line 127 "../src/arena.vala"
	return self ? arena_ref (self) : NULL;
#line 1221 "arena.c"
}

ArenaIterable*
arena_iterable_construct (GType object_type,
                          Arena* arena,
                          gint initial_x,
                          gint initial_y)
{
	ArenaIterable* self = NULL;
	Arena* _tmp0_;
#line 126 "../src/arena.vala"
	g_return_val_if_fail (arena != NULL, NULL);
#line 126 "../src/arena.vala"
	self = (ArenaIterable*) g_type_create_instance (object_type);
#line 127 "../src/arena.vala"
	_tmp0_ = _arena_ref0 (arena);
#line 127 "../src/arena.vala"
	_arena_unref0 (self->priv->arena);
#line 127 "../src/arena.vala"
	self->priv->arena = _tmp0_;
#line 128 "../src/arena.vala"
	self->priv->initial_x = initial_x;
#line 129 "../src/arena.vala"
	self->priv->initial_y = initial_y;
#line 126 "../src/arena.vala"
	return self;
#line 1248 "arena.c"
}

ArenaIterable*
arena_iterable_new (Arena* arena,
                    gint initial_x,
                    gint initial_y)
{
#line 126 "../src/arena.vala"
	return arena_iterable_construct (TYPE_ARENA_ITERABLE, arena, initial_x, initial_y);
#line 1258 "arena.c"
}

ArenaIterableIterator*
arena_iterable_iterator (ArenaIterable* self)
{
	ArenaIterableIterator* _tmp0_;
	ArenaIterableIterator* result;
#line 132 "../src/arena.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 133 "../src/arena.vala"
	_tmp0_ = arena_iterable_iterator_new (self);
#line 133 "../src/arena.vala"
	result = _tmp0_;
#line 133 "../src/arena.vala"
	return result;
#line 1274 "arena.c"
}

static inline gpointer
arena_iterable_iterator_get_instance_private (ArenaIterableIterator* self)
{
	return G_STRUCT_MEMBER_P (self, ArenaIterableIterator_private_offset);
}

ArenaIterableIterator*
arena_iterable_iterator_construct (GType object_type,
                                   ArenaIterable* iterable)
{
	ArenaIterableIterator* self = NULL;
	Arena* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	Arena* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	Arena* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	Arena* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
#line 142 "../src/arena.vala"
	g_return_val_if_fail (iterable != NULL, NULL);
#line 142 "../src/arena.vala"
	self = (ArenaIterableIterator*) g_type_create_instance (object_type);
#line 143 "../src/arena.vala"
	_tmp0_ = iterable->priv->arena;
#line 143 "../src/arena.vala"
	_tmp1_ = arena_get_width (_tmp0_);
#line 143 "../src/arena.vala"
	_tmp2_ = _tmp1_;
#line 143 "../src/arena.vala"
	self->priv->initial_position = iterable->priv->initial_x + (_tmp2_ * iterable->priv->initial_y);
#line 145 "../src/arena.vala"
	_tmp3_ = iterable->priv->arena;
#line 145 "../src/arena.vala"
	_tmp4_ = arena_get_width (_tmp3_);
#line 145 "../src/arena.vala"
	_tmp5_ = _tmp4_;
#line 145 "../src/arena.vala"
	self->priv->width = _tmp5_;
#line 146 "../src/arena.vala"
	_tmp6_ = iterable->priv->arena;
#line 146 "../src/arena.vala"
	_tmp7_ = arena_get_width (_tmp6_);
#line 146 "../src/arena.vala"
	_tmp8_ = _tmp7_;
#line 146 "../src/arena.vala"
	_tmp9_ = iterable->priv->arena;
#line 146 "../src/arena.vala"
	_tmp10_ = arena_get_height (_tmp9_);
#line 146 "../src/arena.vala"
	_tmp11_ = _tmp10_;
#line 146 "../src/arena.vala"
	self->priv->size = _tmp8_ * _tmp11_;
#line 147 "../src/arena.vala"
	self->priv->i = 0;
#line 142 "../src/arena.vala"
	return self;
#line 1338 "arena.c"
}

ArenaIterableIterator*
arena_iterable_iterator_new (ArenaIterable* iterable)
{
#line 142 "../src/arena.vala"
	return arena_iterable_iterator_construct (ARENA_ITERABLE_TYPE_ITERATOR, iterable);
#line 1346 "arena.c"
}

static gpointer
_arena_coords_dup0 (gpointer self)
{
#line 160 "../src/arena.vala"
	return self ? arena_coords_dup (self) : NULL;
#line 1354 "arena.c"
}

ArenaCoords*
arena_iterable_iterator_next_value (ArenaIterableIterator* self)
{
	gint position = 0;
	ArenaCoords _result_ = {0};
	ArenaCoords _tmp0_ = {0};
	ArenaCoords* _tmp1_;
	ArenaCoords* result;
#line 150 "../src/arena.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 151 "../src/arena.vala"
	if (self->priv->i >= self->priv->size) {
#line 152 "../src/arena.vala"
		result = NULL;
#line 152 "../src/arena.vala"
		return result;
#line 1373 "arena.c"
	}
#line 154 "../src/arena.vala"
	position = (self->priv->initial_position + self->priv->i) % self->priv->size;
#line 155 "../src/arena.vala"
	memset (&_tmp0_, 0, sizeof (ArenaCoords));
#line 155 "../src/arena.vala"
	_tmp0_.x = position % self->priv->width;
#line 155 "../src/arena.vala"
	_tmp0_.y = position / self->priv->width;
#line 155 "../src/arena.vala"
	_result_ = _tmp0_;
#line 159 "../src/arena.vala"
	self->priv->i = self->priv->i + 1;
#line 160 "../src/arena.vala"
	_tmp1_ = _arena_coords_dup0 (&_result_);
#line 160 "../src/arena.vala"
	result = _tmp1_;
#line 160 "../src/arena.vala"
	return result;
#line 1393 "arena.c"
}

static void
arena_iterable_value_iterator_init (GValue* value)
{
#line 136 "../src/arena.vala"
	value->data[0].v_pointer = NULL;
#line 1401 "arena.c"
}

static void
arena_iterable_value_iterator_free_value (GValue* value)
{
#line 136 "../src/arena.vala"
	if (value->data[0].v_pointer) {
#line 136 "../src/arena.vala"
		arena_iterable_iterator_unref (value->data[0].v_pointer);
#line 1411 "arena.c"
	}
}

static void
arena_iterable_value_iterator_copy_value (const GValue* src_value,
                                          GValue* dest_value)
{
#line 136 "../src/arena.vala"
	if (src_value->data[0].v_pointer) {
#line 136 "../src/arena.vala"
		dest_value->data[0].v_pointer = arena_iterable_iterator_ref (src_value->data[0].v_pointer);
#line 1423 "arena.c"
	} else {
#line 136 "../src/arena.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1427 "arena.c"
	}
}

static gpointer
arena_iterable_value_iterator_peek_pointer (const GValue* value)
{
#line 136 "../src/arena.vala"
	return value->data[0].v_pointer;
#line 1436 "arena.c"
}

static gchar*
arena_iterable_value_iterator_collect_value (GValue* value,
                                             guint n_collect_values,
                                             GTypeCValue* collect_values,
                                             guint collect_flags)
{
#line 136 "../src/arena.vala"
	if (collect_values[0].v_pointer) {
#line 1447 "arena.c"
		ArenaIterableIterator * object;
		object = collect_values[0].v_pointer;
#line 136 "../src/arena.vala"
		if (object->parent_instance.g_class == NULL) {
#line 136 "../src/arena.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1454 "arena.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 136 "../src/arena.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1458 "arena.c"
		}
#line 136 "../src/arena.vala"
		value->data[0].v_pointer = arena_iterable_iterator_ref (object);
#line 1462 "arena.c"
	} else {
#line 136 "../src/arena.vala"
		value->data[0].v_pointer = NULL;
#line 1466 "arena.c"
	}
#line 136 "../src/arena.vala"
	return NULL;
#line 1470 "arena.c"
}

static gchar*
arena_iterable_value_iterator_lcopy_value (const GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
	ArenaIterableIterator ** object_p;
	object_p = collect_values[0].v_pointer;
#line 136 "../src/arena.vala"
	if (!object_p) {
#line 136 "../src/arena.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1485 "arena.c"
	}
#line 136 "../src/arena.vala"
	if (!value->data[0].v_pointer) {
#line 136 "../src/arena.vala"
		*object_p = NULL;
#line 1491 "arena.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 136 "../src/arena.vala"
		*object_p = value->data[0].v_pointer;
#line 1495 "arena.c"
	} else {
#line 136 "../src/arena.vala"
		*object_p = arena_iterable_iterator_ref (value->data[0].v_pointer);
#line 1499 "arena.c"
	}
#line 136 "../src/arena.vala"
	return NULL;
#line 1503 "arena.c"
}

GParamSpec*
arena_iterable_param_spec_iterator (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags)
{
	ArenaIterableParamSpecIterator* spec;
#line 136 "../src/arena.vala"
	g_return_val_if_fail (g_type_is_a (object_type, ARENA_ITERABLE_TYPE_ITERATOR), NULL);
#line 136 "../src/arena.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 136 "../src/arena.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 136 "../src/arena.vala"
	return G_PARAM_SPEC (spec);
#line 1522 "arena.c"
}

gpointer
arena_iterable_value_get_iterator (const GValue* value)
{
#line 136 "../src/arena.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, ARENA_ITERABLE_TYPE_ITERATOR), NULL);
#line 136 "../src/arena.vala"
	return value->data[0].v_pointer;
#line 1532 "arena.c"
}

void
arena_iterable_value_set_iterator (GValue* value,
                                   gpointer v_object)
{
	ArenaIterableIterator * old;
#line 136 "../src/arena.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, ARENA_ITERABLE_TYPE_ITERATOR));
#line 136 "../src/arena.vala"
	old = value->data[0].v_pointer;
#line 136 "../src/arena.vala"
	if (v_object) {
#line 136 "../src/arena.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, ARENA_ITERABLE_TYPE_ITERATOR));
#line 136 "../src/arena.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 136 "../src/arena.vala"
		value->data[0].v_pointer = v_object;
#line 136 "../src/arena.vala"
		arena_iterable_iterator_ref (value->data[0].v_pointer);
#line 1554 "arena.c"
	} else {
#line 136 "../src/arena.vala"
		value->data[0].v_pointer = NULL;
#line 1558 "arena.c"
	}
#line 136 "../src/arena.vala"
	if (old) {
#line 136 "../src/arena.vala"
		arena_iterable_iterator_unref (old);
#line 1564 "arena.c"
	}
}

void
arena_iterable_value_take_iterator (GValue* value,
                                    gpointer v_object)
{
	ArenaIterableIterator * old;
#line 136 "../src/arena.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, ARENA_ITERABLE_TYPE_ITERATOR));
#line 136 "../src/arena.vala"
	old = value->data[0].v_pointer;
#line 136 "../src/arena.vala"
	if (v_object) {
#line 136 "../src/arena.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, ARENA_ITERABLE_TYPE_ITERATOR));
#line 136 "../src/arena.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 136 "../src/arena.vala"
		value->data[0].v_pointer = v_object;
#line 1585 "arena.c"
	} else {
#line 136 "../src/arena.vala"
		value->data[0].v_pointer = NULL;
#line 1589 "arena.c"
	}
#line 136 "../src/arena.vala"
	if (old) {
#line 136 "../src/arena.vala"
		arena_iterable_iterator_unref (old);
#line 1595 "arena.c"
	}
}

static void
arena_iterable_iterator_class_init (ArenaIterableIteratorClass * klass,
                                    gpointer klass_data)
{
#line 136 "../src/arena.vala"
	arena_iterable_iterator_parent_class = g_type_class_peek_parent (klass);
#line 136 "../src/arena.vala"
	((ArenaIterableIteratorClass *) klass)->finalize = arena_iterable_iterator_finalize;
#line 136 "../src/arena.vala"
	g_type_class_adjust_private_offset (klass, &ArenaIterableIterator_private_offset);
#line 1609 "arena.c"
}

static void
arena_iterable_iterator_instance_init (ArenaIterableIterator * self,
                                       gpointer klass)
{
#line 136 "../src/arena.vala"
	self->priv = arena_iterable_iterator_get_instance_private (self);
#line 136 "../src/arena.vala"
	self->ref_count = 1;
#line 1620 "arena.c"
}

static void
arena_iterable_iterator_finalize (ArenaIterableIterator * obj)
{
	ArenaIterableIterator * self;
#line 136 "../src/arena.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ARENA_ITERABLE_TYPE_ITERATOR, ArenaIterableIterator);
#line 136 "../src/arena.vala"
	g_signal_handlers_destroy (self);
#line 1631 "arena.c"
}

static GType
arena_iterable_iterator_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { arena_iterable_value_iterator_init, arena_iterable_value_iterator_free_value, arena_iterable_value_iterator_copy_value, arena_iterable_value_iterator_peek_pointer, "p", arena_iterable_value_iterator_collect_value, "p", arena_iterable_value_iterator_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ArenaIterableIteratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) arena_iterable_iterator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ArenaIterableIterator), 0, (GInstanceInitFunc) arena_iterable_iterator_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType arena_iterable_iterator_type_id;
	arena_iterable_iterator_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ArenaIterableIterator", &g_define_type_info, &g_define_type_fundamental_info, 0);
	ArenaIterableIterator_private_offset = g_type_add_instance_private (arena_iterable_iterator_type_id, sizeof (ArenaIterableIteratorPrivate));
	return arena_iterable_iterator_type_id;
}

GType
arena_iterable_iterator_get_type (void)
{
	static volatile gsize arena_iterable_iterator_type_id__once = 0;
	if (g_once_init_enter (&arena_iterable_iterator_type_id__once)) {
		GType arena_iterable_iterator_type_id;
		arena_iterable_iterator_type_id = arena_iterable_iterator_get_type_once ();
		g_once_init_leave (&arena_iterable_iterator_type_id__once, arena_iterable_iterator_type_id);
	}
	return arena_iterable_iterator_type_id__once;
}

gpointer
arena_iterable_iterator_ref (gpointer instance)
{
	ArenaIterableIterator * self;
	self = instance;
#line 136 "../src/arena.vala"
	g_atomic_int_inc (&self->ref_count);
#line 136 "../src/arena.vala"
	return instance;
#line 1667 "arena.c"
}

void
arena_iterable_iterator_unref (gpointer instance)
{
	ArenaIterableIterator * self;
	self = instance;
#line 136 "../src/arena.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 136 "../src/arena.vala"
		ARENA_ITERABLE_ITERATOR_GET_CLASS (self)->finalize (self);
#line 136 "../src/arena.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1681 "arena.c"
	}
}

static void
value_arena_iterable_init (GValue* value)
{
#line 121 "../src/arena.vala"
	value->data[0].v_pointer = NULL;
#line 1690 "arena.c"
}

static void
value_arena_iterable_free_value (GValue* value)
{
#line 121 "../src/arena.vala"
	if (value->data[0].v_pointer) {
#line 121 "../src/arena.vala"
		arena_iterable_unref (value->data[0].v_pointer);
#line 1700 "arena.c"
	}
}

static void
value_arena_iterable_copy_value (const GValue* src_value,
                                 GValue* dest_value)
{
#line 121 "../src/arena.vala"
	if (src_value->data[0].v_pointer) {
#line 121 "../src/arena.vala"
		dest_value->data[0].v_pointer = arena_iterable_ref (src_value->data[0].v_pointer);
#line 1712 "arena.c"
	} else {
#line 121 "../src/arena.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1716 "arena.c"
	}
}

static gpointer
value_arena_iterable_peek_pointer (const GValue* value)
{
#line 121 "../src/arena.vala"
	return value->data[0].v_pointer;
#line 1725 "arena.c"
}

static gchar*
value_arena_iterable_collect_value (GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
#line 121 "../src/arena.vala"
	if (collect_values[0].v_pointer) {
#line 1736 "arena.c"
		ArenaIterable * object;
		object = collect_values[0].v_pointer;
#line 121 "../src/arena.vala"
		if (object->parent_instance.g_class == NULL) {
#line 121 "../src/arena.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1743 "arena.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 121 "../src/arena.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1747 "arena.c"
		}
#line 121 "../src/arena.vala"
		value->data[0].v_pointer = arena_iterable_ref (object);
#line 1751 "arena.c"
	} else {
#line 121 "../src/arena.vala"
		value->data[0].v_pointer = NULL;
#line 1755 "arena.c"
	}
#line 121 "../src/arena.vala"
	return NULL;
#line 1759 "arena.c"
}

static gchar*
value_arena_iterable_lcopy_value (const GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
	ArenaIterable ** object_p;
	object_p = collect_values[0].v_pointer;
#line 121 "../src/arena.vala"
	if (!object_p) {
#line 121 "../src/arena.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1774 "arena.c"
	}
#line 121 "../src/arena.vala"
	if (!value->data[0].v_pointer) {
#line 121 "../src/arena.vala"
		*object_p = NULL;
#line 1780 "arena.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 121 "../src/arena.vala"
		*object_p = value->data[0].v_pointer;
#line 1784 "arena.c"
	} else {
#line 121 "../src/arena.vala"
		*object_p = arena_iterable_ref (value->data[0].v_pointer);
#line 1788 "arena.c"
	}
#line 121 "../src/arena.vala"
	return NULL;
#line 1792 "arena.c"
}

GParamSpec*
param_spec_arena_iterable (const gchar* name,
                           const gchar* nick,
                           const gchar* blurb,
                           GType object_type,
                           GParamFlags flags)
{
	ParamSpecArenaIterable* spec;
#line 121 "../src/arena.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_ARENA_ITERABLE), NULL);
#line 121 "../src/arena.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 121 "../src/arena.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 121 "../src/arena.vala"
	return G_PARAM_SPEC (spec);
#line 1811 "arena.c"
}

gpointer
value_get_arena_iterable (const GValue* value)
{
#line 121 "../src/arena.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ARENA_ITERABLE), NULL);
#line 121 "../src/arena.vala"
	return value->data[0].v_pointer;
#line 1821 "arena.c"
}

void
value_set_arena_iterable (GValue* value,
                          gpointer v_object)
{
	ArenaIterable * old;
#line 121 "../src/arena.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ARENA_ITERABLE));
#line 121 "../src/arena.vala"
	old = value->data[0].v_pointer;
#line 121 "../src/arena.vala"
	if (v_object) {
#line 121 "../src/arena.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ARENA_ITERABLE));
#line 121 "../src/arena.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 121 "../src/arena.vala"
		value->data[0].v_pointer = v_object;
#line 121 "../src/arena.vala"
		arena_iterable_ref (value->data[0].v_pointer);
#line 1843 "arena.c"
	} else {
#line 121 "../src/arena.vala"
		value->data[0].v_pointer = NULL;
#line 1847 "arena.c"
	}
#line 121 "../src/arena.vala"
	if (old) {
#line 121 "../src/arena.vala"
		arena_iterable_unref (old);
#line 1853 "arena.c"
	}
}

void
value_take_arena_iterable (GValue* value,
                           gpointer v_object)
{
	ArenaIterable * old;
#line 121 "../src/arena.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ARENA_ITERABLE));
#line 121 "../src/arena.vala"
	old = value->data[0].v_pointer;
#line 121 "../src/arena.vala"
	if (v_object) {
#line 121 "../src/arena.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ARENA_ITERABLE));
#line 121 "../src/arena.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 121 "../src/arena.vala"
		value->data[0].v_pointer = v_object;
#line 1874 "arena.c"
	} else {
#line 121 "../src/arena.vala"
		value->data[0].v_pointer = NULL;
#line 1878 "arena.c"
	}
#line 121 "../src/arena.vala"
	if (old) {
#line 121 "../src/arena.vala"
		arena_iterable_unref (old);
#line 1884 "arena.c"
	}
}

static void
arena_iterable_class_init (ArenaIterableClass * klass,
                           gpointer klass_data)
{
#line 121 "../src/arena.vala"
	arena_iterable_parent_class = g_type_class_peek_parent (klass);
#line 121 "../src/arena.vala"
	((ArenaIterableClass *) klass)->finalize = arena_iterable_finalize;
#line 121 "../src/arena.vala"
	g_type_class_adjust_private_offset (klass, &ArenaIterable_private_offset);
#line 1898 "arena.c"
}

static void
arena_iterable_instance_init (ArenaIterable * self,
                              gpointer klass)
{
#line 121 "../src/arena.vala"
	self->priv = arena_iterable_get_instance_private (self);
#line 121 "../src/arena.vala"
	self->ref_count = 1;
#line 1909 "arena.c"
}

static void
arena_iterable_finalize (ArenaIterable * obj)
{
	ArenaIterable * self;
#line 121 "../src/arena.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ARENA_ITERABLE, ArenaIterable);
#line 121 "../src/arena.vala"
	g_signal_handlers_destroy (self);
#line 122 "../src/arena.vala"
	_arena_unref0 (self->priv->arena);
#line 1922 "arena.c"
}

static GType
arena_iterable_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_arena_iterable_init, value_arena_iterable_free_value, value_arena_iterable_copy_value, value_arena_iterable_peek_pointer, "p", value_arena_iterable_collect_value, "p", value_arena_iterable_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ArenaIterableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) arena_iterable_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ArenaIterable), 0, (GInstanceInitFunc) arena_iterable_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType arena_iterable_type_id;
	arena_iterable_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ArenaIterable", &g_define_type_info, &g_define_type_fundamental_info, 0);
	ArenaIterable_private_offset = g_type_add_instance_private (arena_iterable_type_id, sizeof (ArenaIterablePrivate));
	return arena_iterable_type_id;
}

GType
arena_iterable_get_type (void)
{
	static volatile gsize arena_iterable_type_id__once = 0;
	if (g_once_init_enter (&arena_iterable_type_id__once)) {
		GType arena_iterable_type_id;
		arena_iterable_type_id = arena_iterable_get_type_once ();
		g_once_init_leave (&arena_iterable_type_id__once, arena_iterable_type_id);
	}
	return arena_iterable_type_id__once;
}

gpointer
arena_iterable_ref (gpointer instance)
{
	ArenaIterable * self;
	self = instance;
#line 121 "../src/arena.vala"
	g_atomic_int_inc (&self->ref_count);
#line 121 "../src/arena.vala"
	return instance;
#line 1958 "arena.c"
}

void
arena_iterable_unref (gpointer instance)
{
	ArenaIterable * self;
	self = instance;
#line 121 "../src/arena.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 121 "../src/arena.vala"
		ARENA_ITERABLE_GET_CLASS (self)->finalize (self);
#line 121 "../src/arena.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1972 "arena.c"
	}
}

