/* game.c generated by valac 0.56.17, the Vala compiler
 * generated from game.vala, do not modify */

/*
 * Copyright 2020 Andrey Kutejko <andy128k@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 * For more details see the file COPYING.
 */

#include <glib-object.h>
#include <glib.h>
#include <string.h>
#include <stdlib.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>

#define GAME_GAME_WIDTH 45
#define GAME_GAME_HEIGHT 30
#define GAME_DEAD_DELAY 30
#define GAME_CHANGE_DELAY 20
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	PLAYER_COMMAND_NW = 0,
	PLAYER_COMMAND_N,
	PLAYER_COMMAND_NE,
	PLAYER_COMMAND_W,
	PLAYER_COMMAND_STAY,
	PLAYER_COMMAND_E,
	PLAYER_COMMAND_SW,
	PLAYER_COMMAND_S,
	PLAYER_COMMAND_SE,
	PLAYER_COMMAND_SAFE_TELEPORT,
	PLAYER_COMMAND_RANDOM_TELEPORT,
	PLAYER_COMMAND_WAIT
} PlayerCommand;

#define TYPE_PLAYER_COMMAND (player_command_get_type ())

#define TYPE_DIRECTION (direction_get_type ())
typedef struct _Direction Direction;

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
typedef struct _GamePrivate GamePrivate;
typedef enum  {
	GAME_STATE_PLAYING = 1,
	GAME_STATE_WAITING,
	GAME_STATE_COMPLETE,
	GAME_STATE_DEAD,
	GAME_STATE_TYPE2,
	GAME_STATE_WAITING_TYPE2
} GameState;

#define GAME_TYPE_STATE (game_state_get_type ())

#define TYPE_ARENA (arena_get_type ())
#define ARENA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ARENA, Arena))
#define ARENA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ARENA, ArenaClass))
#define IS_ARENA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ARENA))
#define IS_ARENA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ARENA))
#define ARENA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ARENA, ArenaClass))

typedef struct _Arena Arena;
typedef struct _ArenaClass ArenaClass;

#define TYPE_GAME_CONFIG (game_config_get_type ())
typedef struct _GameConfig GameConfig;

#define ARENA_TYPE_COORDS (arena_coords_get_type ())
typedef struct _ArenaCoords ArenaCoords;
typedef enum  {
	GAME_EVENT_TELEPORTED,
	GAME_EVENT_SPLAT,
	GAME_EVENT_LEVEL_COMPLETE,
	GAME_EVENT_DEATH,
	GAME_EVENT_SCORED,
	GAME_EVENT_VICTORY,
	GAME_EVENT_NO_TELEPORT_LOCATIONS,
	GAME_EVENT_NO_SAFE_TELEPORT_LOCATIONS
} GameEvent;

#define GAME_TYPE_EVENT (game_event_get_type ())
typedef enum  {
	GAME_MOVE_SAFETY_UNSAFE,
	GAME_MOVE_SAFETY_SAFE,
	GAME_MOVE_SAFETY_SUPER_SAFE
} GameMoveSafety;

#define GAME_TYPE_MOVE_SAFETY (game_move_safety_get_type ())
#define _arena_unref0(var) ((var == NULL) ? NULL : (var = (arena_unref (var), NULL)))
#define _arena_coords_free0(var) ((var == NULL) ? NULL : (var = (arena_coords_free (var), NULL)))
#define _g_rand_free0(var) ((var == NULL) ? NULL : (var = (g_rand_free (var), NULL)))
typedef enum  {
	OBJECT_TYPE_PLAYER = 0,
	OBJECT_TYPE_HEAP = 1,
	OBJECT_TYPE_ROBOT1 = 2,
	OBJECT_TYPE_ROBOT2 = 3,
	OBJECT_TYPE_NONE = 99
} ObjectType;

#define TYPE_OBJECT_TYPE (object_type_get_type ())

#define ARENA_ITERABLE_TYPE_ITERATOR (arena_iterable_iterator_get_type ())
#define ARENA_ITERABLE_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ARENA_ITERABLE_TYPE_ITERATOR, ArenaIterableIterator))
#define ARENA_ITERABLE_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ARENA_ITERABLE_TYPE_ITERATOR, ArenaIterableIteratorClass))
#define ARENA_ITERABLE_IS_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ARENA_ITERABLE_TYPE_ITERATOR))
#define ARENA_ITERABLE_IS_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ARENA_ITERABLE_TYPE_ITERATOR))
#define ARENA_ITERABLE_ITERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ARENA_ITERABLE_TYPE_ITERATOR, ArenaIterableIteratorClass))

typedef struct _ArenaIterableIterator ArenaIterableIterator;
typedef struct _ArenaIterableIteratorClass ArenaIterableIteratorClass;

#define TYPE_ARENA_ITERABLE (arena_iterable_get_type ())
#define ARENA_ITERABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ARENA_ITERABLE, ArenaIterable))
#define ARENA_ITERABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ARENA_ITERABLE, ArenaIterableClass))
#define IS_ARENA_ITERABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ARENA_ITERABLE))
#define IS_ARENA_ITERABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ARENA_ITERABLE))
#define ARENA_ITERABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ARENA_ITERABLE, ArenaIterableClass))

typedef struct _ArenaIterable ArenaIterable;
typedef struct _ArenaIterableClass ArenaIterableClass;
#define _arena_iterable_unref0(var) ((var == NULL) ? NULL : (var = (arena_iterable_unref (var), NULL)))
#define _arena_iterable_iterator_unref0(var) ((var == NULL) ? NULL : (var = (arena_iterable_iterator_unref (var), NULL)))

#define GAME_TYPE_ARENA_CHANGE (game_arena_change_get_type ())
typedef struct _GameArenaChange GameArenaChange;
typedef void (*GameKillTracker) (ObjectType victim, gpointer user_data);
typedef struct _Block4Data Block4Data;
typedef ObjectType (*ArenaMapper) (ObjectType obj, gpointer user_data);
#define _game_arena_change_free0(var) ((var == NULL) ? NULL : (var = (game_arena_change_free (var), NULL)))

#define GAME_TYPE_STATUS (game_status_get_type ())
typedef struct _GameStatus GameStatus;
typedef struct _ParamSpecGame ParamSpecGame;
enum  {
	GAME_GAME_EVENT_SIGNAL,
	GAME_NUM_SIGNALS
};
static guint game_signals[GAME_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Direction {
	PlayerCommand cmd;
	gint dx;
	gint dy;
};

struct _Game {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GamePrivate * priv;
};

struct _GameClass {
	GTypeClass parent_class;
	void (*finalize) (Game *self);
};

struct _GameConfig {
	gchar* description;
	gint initial_type1;
	gint initial_type2;
	gint increment_type1;
	gint increment_type2;
	gint maximum_type1;
	gint maximum_type2;
	gint score_type1;
	gint score_type2;
	gint score_type1_waiting;
	gint score_type2_waiting;
	gint score_type1_splatted;
	gint score_type2_splatted;
	gint num_robots_per_safe;
	gint safe_score_boundary;
	gint initial_safe_teleports;
	gint free_safe_teleports;
	gint max_safe_teleports;
	gboolean moveable_heaps;
};

struct _ArenaCoords {
	gint x;
	gint y;
};

struct _GamePrivate {
	GameState _state;
	Arena* _arena;
	GameConfig _config;
	ArenaCoords _player;
	ArenaCoords* _splat;
	GRand* rand;
	gint endlev_counter;
	gint current_level;
	gint score;
	gint kills;
	gint score_step;
	gint safe_teleports;
};

struct _GameArenaChange {
	Arena* arena;
	ArenaCoords player;
	ArenaCoords* push;
};

struct _Block4Data {
	int _ref_count_;
	GeePredicate is_chaser;
	gpointer is_chaser_target;
};

struct _GameStatus {
	gint score;
	gint current_level;
	gint safe_teleports;
};

struct _ParamSpecGame {
	GParamSpec parent_instance;
};

static gint Game_private_offset;
static gpointer game_parent_class = NULL;

VALA_EXTERN GType player_command_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PlayerCommand player_command_from_direction (gint dx,
                                             gint dy);
VALA_EXTERN GType direction_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Direction* direction_dup (const Direction* self);
VALA_EXTERN void direction_free (Direction* self);
VALA_EXTERN gboolean player_command_to_direction (PlayerCommand self,
                                      gint* dx,
                                      gint* dy);
VALA_EXTERN gpointer game_ref (gpointer instance);
VALA_EXTERN void game_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_game (const gchar* name,
                             const gchar* nick,
                             const gchar* blurb,
                             GType object_type,
                             GParamFlags flags);
VALA_EXTERN void value_set_game (GValue* value,
                     gpointer v_object);
VALA_EXTERN void value_take_game (GValue* value,
                      gpointer v_object);
VALA_EXTERN gpointer value_get_game (const GValue* value);
VALA_EXTERN GType game_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Game, game_unref)
VALA_EXTERN GType game_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gpointer arena_ref (gpointer instance);
VALA_EXTERN void arena_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_arena (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags);
VALA_EXTERN void value_set_arena (GValue* value,
                      gpointer v_object);
VALA_EXTERN void value_take_arena (GValue* value,
                       gpointer v_object);
VALA_EXTERN gpointer value_get_arena (const GValue* value);
VALA_EXTERN GType arena_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Arena, arena_unref)
VALA_EXTERN GType game_config_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GameConfig* game_config_dup (const GameConfig* self);
VALA_EXTERN void game_config_free (GameConfig* self);
VALA_EXTERN void game_config_copy (const GameConfig* self,
                       GameConfig* dest);
VALA_EXTERN void game_config_destroy (GameConfig* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (GameConfig, game_config_destroy)
VALA_EXTERN GType arena_coords_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ArenaCoords* arena_coords_dup (const ArenaCoords* self);
VALA_EXTERN void arena_coords_free (ArenaCoords* self);
VALA_EXTERN GType game_event_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType game_move_safety_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Game* game_new (void);
VALA_EXTERN Game* game_construct (GType object_type);
VALA_EXTERN Arena* arena_new (gint width,
                  gint height);
VALA_EXTERN Arena* arena_construct (GType object_type,
                        gint width,
                        gint height);
static void game_set_arena (Game* self,
                     Arena* value);
static void game_set_state (Game* self,
                     GameState value);
static void game_kill_player (Game* self);
VALA_EXTERN Arena* game_get_arena (Game* self);
VALA_EXTERN GType object_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void arena_set (Arena* self,
                gint x,
                gint y,
                ObjectType obj);
VALA_EXTERN void game_get_player (Game* self,
                      ArenaCoords * result);
static void game_add_kill (Game* self,
                    ObjectType type);
VALA_EXTERN GameState game_get_state (Game* self);
VALA_EXTERN void game_get_config (Game* self,
                      GameConfig * result);
static gint game_max_robots (Game* self);
VALA_EXTERN gint arena_get_width (Arena* self);
VALA_EXTERN gint arena_get_height (Arena* self);
static void game_generate_level (Game* self);
VALA_EXTERN void arena_clear (Arena* self);
static void game_set_player (Game* self,
                      ArenaCoords * value);
static void game_place_randomly (Game* self,
                          ObjectType obj);
VALA_EXTERN gpointer arena_iterable_iterator_ref (gpointer instance);
VALA_EXTERN void arena_iterable_iterator_unref (gpointer instance);
VALA_EXTERN GParamSpec* arena_iterable_param_spec_iterator (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags);
VALA_EXTERN void arena_iterable_value_set_iterator (GValue* value,
                                        gpointer v_object);
VALA_EXTERN void arena_iterable_value_take_iterator (GValue* value,
                                         gpointer v_object);
VALA_EXTERN gpointer arena_iterable_value_get_iterator (const GValue* value);
VALA_EXTERN GType arena_iterable_iterator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ArenaIterableIterator, arena_iterable_iterator_unref)
VALA_EXTERN gpointer arena_iterable_ref (gpointer instance);
VALA_EXTERN void arena_iterable_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_arena_iterable (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
VALA_EXTERN void value_set_arena_iterable (GValue* value,
                               gpointer v_object);
VALA_EXTERN void value_take_arena_iterable (GValue* value,
                                gpointer v_object);
VALA_EXTERN gpointer value_get_arena_iterable (const GValue* value);
VALA_EXTERN GType arena_iterable_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ArenaIterable, arena_iterable_unref)
VALA_EXTERN ArenaIterable* arena_iterate_from (Arena* self,
                                   gint x,
                                   gint y);
VALA_EXTERN ArenaIterableIterator* arena_iterable_iterator (ArenaIterable* self);
VALA_EXTERN ArenaCoords* arena_iterable_iterator_next_value (ArenaIterableIterator* self);
VALA_EXTERN ObjectType arena_get (Arena* self,
                      gint x,
                      gint y);
static GType game_arena_change_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GameArenaChange* game_arena_change_dup (const GameArenaChange* self);
static void game_arena_change_free (GameArenaChange* self);
static void game_arena_change_copy (const GameArenaChange* self,
                             GameArenaChange* dest);
static void game_arena_change_destroy (GameArenaChange* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (GameArenaChange, game_arena_change_destroy)
static void game_update_arena (Game* self,
                        GameArenaChange* change);
static void game_set_splat (Game* self,
                     ArenaCoords* value);
VALA_EXTERN gint arena_count (Arena* self,
                  GeePredicate predicate,
                  gpointer predicate_target);
static gboolean ___lambda14_ (Game* self,
                       ObjectType obj);
static gboolean ____lambda14__gee_predicate (gconstpointer g,
                                      gpointer self);
VALA_EXTERN void game_tick (Game* self);
static Arena* game_move_type2_robots (Game* self);
static void game_move_robots (Game* self);
VALA_EXTERN void game_start_new_game (Game* self);
static Arena* game_move_all_robots (Game* self);
static Arena* game_chase (Arena* arena,
                   GeePredicate is_chaser,
                   gpointer is_chaser_target,
                   gint x,
                   gint y,
                   GameKillTracker track_kill,
                   gpointer track_kill_target);
static gboolean __lambda18_ (Game* self,
                      ObjectType obj);
static gboolean ___lambda18__gee_predicate (gconstpointer g,
                                     gpointer self);
static void __lambda19_ (Game* self,
                  ObjectType victim);
static void ___lambda19__game_kill_tracker (ObjectType victim,
                                     gpointer self);
static gboolean __lambda16_ (Game* self,
                      ObjectType obj);
static gboolean ___lambda16__gee_predicate (gconstpointer g,
                                     gpointer self);
static void __lambda17_ (Game* self,
                  ObjectType victim);
static void ___lambda17__game_kill_tracker (ObjectType victim,
                                     gpointer self);
static gboolean __lambda20_ (Game* self,
                      ObjectType obj);
static gboolean ___lambda20__gee_predicate (gconstpointer g,
                                     gpointer self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
VALA_EXTERN Arena* arena_map (Arena* self,
                  ArenaMapper mapper,
                  gpointer mapper_target);
static ObjectType __lambda15_ (Block4Data* _data4_,
                        ObjectType obj);
static ObjectType ___lambda15__arena_mapper (ObjectType obj,
                                      gpointer self);
static gboolean game_check_safe (Game* self,
                          GameArenaChange* change);
static gboolean __lambda21_ (Game* self,
                      ObjectType obj);
static gboolean ___lambda21__gee_predicate (gconstpointer g,
                                     gpointer self);
static gboolean __lambda22_ (Game* self,
                      ObjectType obj);
static gboolean ___lambda22__gee_predicate (gconstpointer g,
                                     gpointer self);
static GameArenaChange* game_try_push_heap (Game* self,
                                     gint dx,
                                     gint dy);
VALA_EXTERN void arena_coords_move (ArenaCoords *self,
                        gint dx,
                        gint dy,
                        ArenaCoords* result);
VALA_EXTERN gboolean arena_are_coords_valid (Arena* self,
                                 ArenaCoords* coords);
static ObjectType __lambda23_ (Game* self,
                        ObjectType obj);
static ObjectType ___lambda23__arena_mapper (ObjectType obj,
                                      gpointer self);
static GameArenaChange* game_try_player_move (Game* self,
                                       gint dx,
                                       gint dy);
static void game_move_player_to (Game* self,
                          ArenaCoords* coords,
                          GameArenaChange* result);
static gboolean game_safe_move_available (Game* self);
static ObjectType __lambda24_ (Game* self,
                        ObjectType obj);
static ObjectType ___lambda24__arena_mapper (ObjectType obj,
                                      gpointer self);
static gboolean game_player_move (Game* self,
                           gint dx,
                           gint dy,
                           GameMoveSafety safety);
static gboolean game_random_teleport (Game* self);
static gboolean game_safe_teleport (Game* self);
VALA_EXTERN gboolean game_player_command (Game* self,
                              PlayerCommand cmd,
                              GameMoveSafety safety);
VALA_EXTERN void game_set_config (Game* self,
                      GameConfig * value);
VALA_EXTERN gint game_get_width (Game* self);
VALA_EXTERN gint game_get_height (Game* self);
VALA_EXTERN ArenaCoords* game_get_splat (Game* self);
VALA_EXTERN GType game_status_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GameStatus* game_status_dup (const GameStatus* self);
VALA_EXTERN void game_status_free (GameStatus* self);
VALA_EXTERN void game_get_status (Game* self,
                      GameStatus * result);
static void g_cclosure_user_marshal_VOID__ENUM_INT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data);
static void game_finalize (Game * obj);
static GType game_get_type_once (void);

const Direction directions[9] = {{PLAYER_COMMAND_NW, -1, -1}, {PLAYER_COMMAND_N, 0, -1}, {PLAYER_COMMAND_NE, 1, -1}, {PLAYER_COMMAND_W, -1, 0}, {PLAYER_COMMAND_STAY, 0, 0}, {PLAYER_COMMAND_E, 1, 0}, {PLAYER_COMMAND_SW, -1, 1}, {PLAYER_COMMAND_S, 0, 1}, {PLAYER_COMMAND_SE, 1, 1}};

PlayerCommand
player_command_from_direction (gint dx,
                               gint dy)
{
	PlayerCommand result;
	{
		Direction* direction_collection = NULL;
		gint direction_collection_length1 = 0;
		gint _direction_collection_size_ = 0;
		gint direction_it = 0;
#line 35 "../src/game.vala"
		direction_collection = directions;
#line 35 "../src/game.vala"
		direction_collection_length1 = G_N_ELEMENTS (directions);
#line 35 "../src/game.vala"
		for (direction_it = 0; direction_it < direction_collection_length1; direction_it = direction_it + 1) {
#line 526 "game.c"
			Direction direction = {0};
#line 35 "../src/game.vala"
			direction = direction_collection[direction_it];
#line 530 "game.c"
			{
				gboolean _tmp0_ = FALSE;
				Direction _tmp1_;
#line 36 "../src/game.vala"
				_tmp1_ = direction;
#line 36 "../src/game.vala"
				if (_tmp1_.dx == dx) {
#line 538 "game.c"
					Direction _tmp2_;
#line 36 "../src/game.vala"
					_tmp2_ = direction;
#line 36 "../src/game.vala"
					_tmp0_ = _tmp2_.dy == dy;
#line 544 "game.c"
				} else {
#line 36 "../src/game.vala"
					_tmp0_ = FALSE;
#line 548 "game.c"
				}
#line 36 "../src/game.vala"
				if (_tmp0_) {
#line 552 "game.c"
					Direction _tmp3_;
#line 37 "../src/game.vala"
					_tmp3_ = direction;
#line 37 "../src/game.vala"
					result = _tmp3_.cmd;
#line 37 "../src/game.vala"
					return result;
#line 560 "game.c"
				}
			}
		}
	}
#line 40 "../src/game.vala"
	result = PLAYER_COMMAND_STAY;
#line 40 "../src/game.vala"
	return result;
#line 569 "game.c"
}

gboolean
player_command_to_direction (PlayerCommand self,
                             gint* dx,
                             gint* dy)
{
	gint _vala_dx = 0;
	gint _vala_dy = 0;
	gboolean result;
	{
		Direction* direction_collection = NULL;
		gint direction_collection_length1 = 0;
		gint _direction_collection_size_ = 0;
		gint direction_it = 0;
#line 44 "../src/game.vala"
		direction_collection = directions;
#line 44 "../src/game.vala"
		direction_collection_length1 = G_N_ELEMENTS (directions);
#line 44 "../src/game.vala"
		for (direction_it = 0; direction_it < direction_collection_length1; direction_it = direction_it + 1) {
#line 591 "game.c"
			Direction direction = {0};
#line 44 "../src/game.vala"
			direction = direction_collection[direction_it];
#line 595 "game.c"
			{
				Direction _tmp0_;
#line 45 "../src/game.vala"
				_tmp0_ = direction;
#line 45 "../src/game.vala"
				if (_tmp0_.cmd == self) {
#line 602 "game.c"
					Direction _tmp1_;
					Direction _tmp2_;
#line 46 "../src/game.vala"
					_tmp1_ = direction;
#line 46 "../src/game.vala"
					_vala_dx = _tmp1_.dx;
#line 47 "../src/game.vala"
					_tmp2_ = direction;
#line 47 "../src/game.vala"
					_vala_dy = _tmp2_.dy;
#line 48 "../src/game.vala"
					result = TRUE;
#line 48 "../src/game.vala"
					if (dx) {
#line 48 "../src/game.vala"
						*dx = _vala_dx;
#line 619 "game.c"
					}
#line 48 "../src/game.vala"
					if (dy) {
#line 48 "../src/game.vala"
						*dy = _vala_dy;
#line 625 "game.c"
					}
#line 48 "../src/game.vala"
					return result;
#line 629 "game.c"
				}
			}
		}
	}
#line 51 "../src/game.vala"
	_vala_dx = 0;
#line 52 "../src/game.vala"
	_vala_dy = 0;
#line 53 "../src/game.vala"
	result = FALSE;
#line 53 "../src/game.vala"
	if (dx) {
#line 53 "../src/game.vala"
		*dx = _vala_dx;
#line 644 "game.c"
	}
#line 53 "../src/game.vala"
	if (dy) {
#line 53 "../src/game.vala"
		*dy = _vala_dy;
#line 650 "game.c"
	}
#line 53 "../src/game.vala"
	return result;
#line 654 "game.c"
}

static GType
player_command_get_type_once (void)
{
	static const GEnumValue values[] = {{PLAYER_COMMAND_NW, "PLAYER_COMMAND_NW", "nw"}, {PLAYER_COMMAND_N, "PLAYER_COMMAND_N", "n"}, {PLAYER_COMMAND_NE, "PLAYER_COMMAND_NE", "ne"}, {PLAYER_COMMAND_W, "PLAYER_COMMAND_W", "w"}, {PLAYER_COMMAND_STAY, "PLAYER_COMMAND_STAY", "stay"}, {PLAYER_COMMAND_E, "PLAYER_COMMAND_E", "e"}, {PLAYER_COMMAND_SW, "PLAYER_COMMAND_SW", "sw"}, {PLAYER_COMMAND_S, "PLAYER_COMMAND_S", "s"}, {PLAYER_COMMAND_SE, "PLAYER_COMMAND_SE", "se"}, {PLAYER_COMMAND_SAFE_TELEPORT, "PLAYER_COMMAND_SAFE_TELEPORT", "safe-teleport"}, {PLAYER_COMMAND_RANDOM_TELEPORT, "PLAYER_COMMAND_RANDOM_TELEPORT", "random-teleport"}, {PLAYER_COMMAND_WAIT, "PLAYER_COMMAND_WAIT", "wait"}, {0, NULL, NULL}};
	GType player_command_type_id;
	player_command_type_id = g_enum_register_static ("PlayerCommand", values);
	return player_command_type_id;
}

GType
player_command_get_type (void)
{
	static volatile gsize player_command_type_id__once = 0;
	if (g_once_init_enter (&player_command_type_id__once)) {
		GType player_command_type_id;
		player_command_type_id = player_command_get_type_once ();
		g_once_init_leave (&player_command_type_id__once, player_command_type_id);
	}
	return player_command_type_id__once;
}

Direction*
direction_dup (const Direction* self)
{
	Direction* dup;
#line 57 "../src/game.vala"
	dup = g_new0 (Direction, 1);
#line 57 "../src/game.vala"
	memcpy (dup, self, sizeof (Direction));
#line 57 "../src/game.vala"
	return dup;
#line 688 "game.c"
}

void
direction_free (Direction* self)
{
#line 57 "../src/game.vala"
	g_free (self);
#line 696 "game.c"
}

static GType
direction_get_type_once (void)
{
	GType direction_type_id;
	direction_type_id = g_boxed_type_register_static ("Direction", (GBoxedCopyFunc) direction_dup, (GBoxedFreeFunc) direction_free);
	return direction_type_id;
}

GType
direction_get_type (void)
{
	static volatile gsize direction_type_id__once = 0;
	if (g_once_init_enter (&direction_type_id__once)) {
		GType direction_type_id;
		direction_type_id = direction_get_type_once ();
		g_once_init_leave (&direction_type_id__once, direction_type_id);
	}
	return direction_type_id__once;
}

static inline gpointer
game_get_instance_private (Game* self)
{
	return G_STRUCT_MEMBER_P (self, Game_private_offset);
}

static GType
game_state_get_type_once (void)
{
	static const GEnumValue values[] = {{GAME_STATE_PLAYING, "GAME_STATE_PLAYING", "playing"}, {GAME_STATE_WAITING, "GAME_STATE_WAITING", "waiting"}, {GAME_STATE_COMPLETE, "GAME_STATE_COMPLETE", "complete"}, {GAME_STATE_DEAD, "GAME_STATE_DEAD", "dead"}, {GAME_STATE_TYPE2, "GAME_STATE_TYPE2", "type2"}, {GAME_STATE_WAITING_TYPE2, "GAME_STATE_WAITING_TYPE2", "waiting-type2"}, {0, NULL, NULL}};
	GType game_state_type_id;
	game_state_type_id = g_enum_register_static ("GameState", values);
	return game_state_type_id;
}

GType
game_state_get_type (void)
{
	static volatile gsize game_state_type_id__once = 0;
	if (g_once_init_enter (&game_state_type_id__once)) {
		GType game_state_type_id;
		game_state_type_id = game_state_get_type_once ();
		g_once_init_leave (&game_state_type_id__once, game_state_type_id);
	}
	return game_state_type_id__once;
}

static GType
game_event_get_type_once (void)
{
	static const GEnumValue values[] = {{GAME_EVENT_TELEPORTED, "GAME_EVENT_TELEPORTED", "teleported"}, {GAME_EVENT_SPLAT, "GAME_EVENT_SPLAT", "splat"}, {GAME_EVENT_LEVEL_COMPLETE, "GAME_EVENT_LEVEL_COMPLETE", "level-complete"}, {GAME_EVENT_DEATH, "GAME_EVENT_DEATH", "death"}, {GAME_EVENT_SCORED, "GAME_EVENT_SCORED", "scored"}, {GAME_EVENT_VICTORY, "GAME_EVENT_VICTORY", "victory"}, {GAME_EVENT_NO_TELEPORT_LOCATIONS, "GAME_EVENT_NO_TELEPORT_LOCATIONS", "no-teleport-locations"}, {GAME_EVENT_NO_SAFE_TELEPORT_LOCATIONS, "GAME_EVENT_NO_SAFE_TELEPORT_LOCATIONS", "no-safe-teleport-locations"}, {0, NULL, NULL}};
	GType game_event_type_id;
	game_event_type_id = g_enum_register_static ("GameEvent", values);
	return game_event_type_id;
}

GType
game_event_get_type (void)
{
	static volatile gsize game_event_type_id__once = 0;
	if (g_once_init_enter (&game_event_type_id__once)) {
		GType game_event_type_id;
		game_event_type_id = game_event_get_type_once ();
		g_once_init_leave (&game_event_type_id__once, game_event_type_id);
	}
	return game_event_type_id__once;
}

static GType
game_move_safety_get_type_once (void)
{
	static const GEnumValue values[] = {{GAME_MOVE_SAFETY_UNSAFE, "GAME_MOVE_SAFETY_UNSAFE", "unsafe"}, {GAME_MOVE_SAFETY_SAFE, "GAME_MOVE_SAFETY_SAFE", "safe"}, {GAME_MOVE_SAFETY_SUPER_SAFE, "GAME_MOVE_SAFETY_SUPER_SAFE", "super-safe"}, {0, NULL, NULL}};
	GType game_move_safety_type_id;
	game_move_safety_type_id = g_enum_register_static ("GameMoveSafety", values);
	return game_move_safety_type_id;
}

GType
game_move_safety_get_type (void)
{
	static volatile gsize game_move_safety_type_id__once = 0;
	if (g_once_init_enter (&game_move_safety_type_id__once)) {
		GType game_move_safety_type_id;
		game_move_safety_type_id = game_move_safety_get_type_once ();
		g_once_init_leave (&game_move_safety_type_id__once, game_move_safety_type_id);
	}
	return game_move_safety_type_id__once;
}

Game*
game_construct (GType object_type)
{
	Game* self = NULL;
	Arena* _tmp0_;
	Arena* _tmp1_;
	GRand* _tmp2_;
#line 137 "../src/game.vala"
	self = (Game*) g_type_create_instance (object_type);
#line 138 "../src/game.vala"
	_tmp0_ = arena_new (GAME_GAME_WIDTH, GAME_GAME_HEIGHT);
#line 138 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 138 "../src/game.vala"
	game_set_arena (self, _tmp1_);
#line 138 "../src/game.vala"
	_arena_unref0 (_tmp1_);
#line 139 "../src/game.vala"
	_tmp2_ = g_rand_new ();
#line 139 "../src/game.vala"
	_g_rand_free0 (self->priv->rand);
#line 139 "../src/game.vala"
	self->priv->rand = _tmp2_;
#line 140 "../src/game.vala"
	game_set_state (self, GAME_STATE_PLAYING);
#line 137 "../src/game.vala"
	return self;
#line 815 "game.c"
}

Game*
game_new (void)
{
#line 137 "../src/game.vala"
	return game_construct (TYPE_GAME);
#line 823 "game.c"
}

/**
     * Ends the current game.
     **/
static void
game_kill_player (Game* self)
{
	Arena* _tmp0_;
	ArenaCoords _tmp1_;
	ArenaCoords _tmp2_;
#line 159 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 160 "../src/game.vala"
	game_set_state (self, GAME_STATE_DEAD);
#line 161 "../src/game.vala"
	_tmp0_ = self->priv->_arena;
#line 161 "../src/game.vala"
	_tmp1_ = self->priv->_player;
#line 161 "../src/game.vala"
	_tmp2_ = self->priv->_player;
#line 161 "../src/game.vala"
	arena_set (_tmp0_, _tmp1_.x, _tmp2_.y, OBJECT_TYPE_PLAYER);
#line 162 "../src/game.vala"
	self->priv->endlev_counter = 0;
#line 163 "../src/game.vala"
	g_signal_emit (self, game_signals[GAME_GAME_EVENT_SIGNAL], 0, GAME_EVENT_DEATH, 0);
#line 851 "game.c"
}

/**
     * add_kill
     * @type: robot type
     *
     * Description:
     * registers a robot kill and updates the score
     **/
static void
game_add_kill (Game* self,
               ObjectType type)
{
	gint si = 0;
	gboolean _tmp0_ = FALSE;
	GameState _tmp1_;
	GameConfig _tmp7_;
	GameConfig _tmp10_;
	GameConfig _tmp13_;
#line 173 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 175 "../src/game.vala"
	_tmp1_ = self->priv->_state;
#line 175 "../src/game.vala"
	if (_tmp1_ == GAME_STATE_WAITING) {
#line 175 "../src/game.vala"
		_tmp0_ = TRUE;
#line 879 "game.c"
	} else {
		GameState _tmp2_;
#line 175 "../src/game.vala"
		_tmp2_ = self->priv->_state;
#line 175 "../src/game.vala"
		_tmp0_ = _tmp2_ == GAME_STATE_WAITING_TYPE2;
#line 886 "game.c"
	}
#line 175 "../src/game.vala"
	if (_tmp0_) {
#line 176 "../src/game.vala"
		if (type == OBJECT_TYPE_ROBOT1) {
#line 892 "game.c"
			GameConfig _tmp3_;
#line 177 "../src/game.vala"
			_tmp3_ = self->priv->_config;
#line 177 "../src/game.vala"
			si = _tmp3_.score_type1_waiting;
#line 178 "../src/game.vala"
			self->priv->kills = self->priv->kills + 1;
#line 900 "game.c"
		} else {
			GameConfig _tmp4_;
#line 180 "../src/game.vala"
			_tmp4_ = self->priv->_config;
#line 180 "../src/game.vala"
			si = _tmp4_.score_type2_waiting;
#line 181 "../src/game.vala"
			self->priv->kills = self->priv->kills + 2;
#line 909 "game.c"
		}
	} else {
#line 184 "../src/game.vala"
		if (type == OBJECT_TYPE_ROBOT1) {
#line 914 "game.c"
			GameConfig _tmp5_;
#line 185 "../src/game.vala"
			_tmp5_ = self->priv->_config;
#line 185 "../src/game.vala"
			si = _tmp5_.score_type1;
#line 920 "game.c"
		} else {
			GameConfig _tmp6_;
#line 187 "../src/game.vala"
			_tmp6_ = self->priv->_config;
#line 187 "../src/game.vala"
			si = _tmp6_.score_type2;
#line 927 "game.c"
		}
	}
#line 191 "../src/game.vala"
	self->priv->score = self->priv->score + si;
#line 192 "../src/game.vala"
	self->priv->score_step = self->priv->score_step + si;
#line 194 "../src/game.vala"
	_tmp7_ = self->priv->_config;
#line 194 "../src/game.vala"
	if (_tmp7_.safe_score_boundary > 0) {
#line 195 "../src/game.vala"
		while (TRUE) {
#line 940 "game.c"
			GameConfig _tmp8_;
			GameConfig _tmp9_;
#line 195 "../src/game.vala"
			_tmp8_ = self->priv->_config;
#line 195 "../src/game.vala"
			if (!(self->priv->score_step >= _tmp8_.safe_score_boundary)) {
#line 195 "../src/game.vala"
				break;
#line 949 "game.c"
			}
#line 196 "../src/game.vala"
			self->priv->safe_teleports = self->priv->safe_teleports + 1;
#line 197 "../src/game.vala"
			_tmp9_ = self->priv->_config;
#line 197 "../src/game.vala"
			self->priv->score_step = self->priv->score_step - _tmp9_.safe_score_boundary;
#line 957 "game.c"
		}
	}
#line 201 "../src/game.vala"
	_tmp10_ = self->priv->_config;
#line 201 "../src/game.vala"
	if (_tmp10_.num_robots_per_safe > 0) {
#line 202 "../src/game.vala"
		while (TRUE) {
#line 966 "game.c"
			GameConfig _tmp11_;
			GameConfig _tmp12_;
#line 202 "../src/game.vala"
			_tmp11_ = self->priv->_config;
#line 202 "../src/game.vala"
			if (!(self->priv->kills >= _tmp11_.num_robots_per_safe)) {
#line 202 "../src/game.vala"
				break;
#line 975 "game.c"
			}
#line 203 "../src/game.vala"
			self->priv->safe_teleports = self->priv->safe_teleports + 1;
#line 204 "../src/game.vala"
			_tmp12_ = self->priv->_config;
#line 204 "../src/game.vala"
			self->priv->kills = self->priv->kills - _tmp12_.num_robots_per_safe;
#line 983 "game.c"
		}
	}
#line 208 "../src/game.vala"
	_tmp13_ = self->priv->_config;
#line 208 "../src/game.vala"
	if (self->priv->safe_teleports > _tmp13_.max_safe_teleports) {
#line 990 "game.c"
		GameConfig _tmp14_;
#line 209 "../src/game.vala"
		_tmp14_ = self->priv->_config;
#line 209 "../src/game.vala"
		self->priv->safe_teleports = _tmp14_.max_safe_teleports;
#line 996 "game.c"
	}
}

static gint
game_max_robots (Game* self)
{
	Arena* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	Arena* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint result;
#line 213 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 214 "../src/game.vala"
	_tmp0_ = self->priv->_arena;
#line 214 "../src/game.vala"
	_tmp1_ = arena_get_width (_tmp0_);
#line 214 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 214 "../src/game.vala"
	_tmp3_ = self->priv->_arena;
#line 214 "../src/game.vala"
	_tmp4_ = arena_get_height (_tmp3_);
#line 214 "../src/game.vala"
	_tmp5_ = _tmp4_;
#line 214 "../src/game.vala"
	result = (_tmp2_ * _tmp5_) / 2;
#line 214 "../src/game.vala"
	return result;
#line 1028 "game.c"
}

/**
     * Creates a new level and populates it with robots
     **/
static void
game_generate_level (Game* self)
{
	Arena* _tmp0_;
	Arena* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	Arena* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	ArenaCoords _tmp7_ = {0};
	Arena* _tmp8_;
	ArenaCoords _tmp9_;
	ArenaCoords _tmp10_;
	gint num_robots1 = 0;
	GameConfig _tmp11_;
	GameConfig _tmp12_;
	GameConfig _tmp13_;
	gint num_robots2 = 0;
	GameConfig _tmp14_;
	GameConfig _tmp15_;
	GameConfig _tmp16_;
	GameConfig _tmp19_;
	GameConfig _tmp20_;
#line 220 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 221 "../src/game.vala"
	_tmp0_ = self->priv->_arena;
#line 221 "../src/game.vala"
	arena_clear (_tmp0_);
#line 223 "../src/game.vala"
	_tmp1_ = self->priv->_arena;
#line 223 "../src/game.vala"
	_tmp2_ = arena_get_width (_tmp1_);
#line 223 "../src/game.vala"
	_tmp3_ = _tmp2_;
#line 223 "../src/game.vala"
	_tmp4_ = self->priv->_arena;
#line 223 "../src/game.vala"
	_tmp5_ = arena_get_height (_tmp4_);
#line 223 "../src/game.vala"
	_tmp6_ = _tmp5_;
#line 223 "../src/game.vala"
	memset (&_tmp7_, 0, sizeof (ArenaCoords));
#line 223 "../src/game.vala"
	_tmp7_.x = _tmp3_ / 2;
#line 223 "../src/game.vala"
	_tmp7_.y = _tmp6_ / 2;
#line 223 "../src/game.vala"
	game_set_player (self, &_tmp7_);
#line 227 "../src/game.vala"
	_tmp8_ = self->priv->_arena;
#line 227 "../src/game.vala"
	_tmp9_ = self->priv->_player;
#line 227 "../src/game.vala"
	_tmp10_ = self->priv->_player;
#line 227 "../src/game.vala"
	arena_set (_tmp8_, _tmp9_.x, _tmp10_.y, OBJECT_TYPE_PLAYER);
#line 229 "../src/game.vala"
	_tmp11_ = self->priv->_config;
#line 229 "../src/game.vala"
	_tmp12_ = self->priv->_config;
#line 229 "../src/game.vala"
	_tmp13_ = self->priv->_config;
#line 229 "../src/game.vala"
	num_robots1 = MIN (_tmp11_.initial_type1 + (_tmp12_.increment_type1 * self->priv->current_level), _tmp13_.maximum_type1);
#line 233 "../src/game.vala"
	_tmp14_ = self->priv->_config;
#line 233 "../src/game.vala"
	_tmp15_ = self->priv->_config;
#line 233 "../src/game.vala"
	_tmp16_ = self->priv->_config;
#line 233 "../src/game.vala"
	num_robots2 = MIN (_tmp14_.initial_type2 + (_tmp15_.increment_type2 * self->priv->current_level), _tmp16_.maximum_type2);
#line 238 "../src/game.vala"
	if ((num_robots1 + num_robots2) > game_max_robots (self)) {
#line 1110 "game.c"
		GameConfig _tmp17_;
		GameConfig _tmp18_;
#line 239 "../src/game.vala"
		self->priv->current_level = 0;
#line 240 "../src/game.vala"
		_tmp17_ = self->priv->_config;
#line 240 "../src/game.vala"
		num_robots1 = _tmp17_.initial_type1;
#line 241 "../src/game.vala"
		_tmp18_ = self->priv->_config;
#line 241 "../src/game.vala"
		num_robots2 = _tmp18_.initial_type2;
#line 243 "../src/game.vala"
		g_signal_emit (self, game_signals[GAME_GAME_EVENT_SIGNAL], 0, GAME_EVENT_VICTORY, 0);
#line 1125 "game.c"
	}
#line 246 "../src/game.vala"
	_tmp19_ = self->priv->_config;
#line 246 "../src/game.vala"
	self->priv->safe_teleports = self->priv->safe_teleports + _tmp19_.free_safe_teleports;
#line 248 "../src/game.vala"
	_tmp20_ = self->priv->_config;
#line 248 "../src/game.vala"
	if (self->priv->safe_teleports > _tmp20_.max_safe_teleports) {
#line 1135 "game.c"
		GameConfig _tmp21_;
#line 249 "../src/game.vala"
		_tmp21_ = self->priv->_config;
#line 249 "../src/game.vala"
		self->priv->safe_teleports = _tmp21_.max_safe_teleports;
#line 1141 "game.c"
	}
	{
		gint i = 0;
#line 252 "../src/game.vala"
		i = 0;
#line 1147 "game.c"
		{
			gboolean _tmp22_ = FALSE;
#line 252 "../src/game.vala"
			_tmp22_ = TRUE;
#line 252 "../src/game.vala"
			while (TRUE) {
#line 252 "../src/game.vala"
				if (!_tmp22_) {
#line 1156 "game.c"
					gint _tmp23_;
#line 252 "../src/game.vala"
					i = i + 1;
#line 252 "../src/game.vala"
					_tmp23_ = i;
#line 1162 "game.c"
				}
#line 252 "../src/game.vala"
				_tmp22_ = FALSE;
#line 252 "../src/game.vala"
				if (!(i < num_robots1)) {
#line 252 "../src/game.vala"
					break;
#line 1170 "game.c"
				}
#line 253 "../src/game.vala"
				game_place_randomly (self, OBJECT_TYPE_ROBOT1);
#line 1174 "game.c"
			}
		}
	}
	{
		gint i = 0;
#line 256 "../src/game.vala"
		i = 0;
#line 1182 "game.c"
		{
			gboolean _tmp24_ = FALSE;
#line 256 "../src/game.vala"
			_tmp24_ = TRUE;
#line 256 "../src/game.vala"
			while (TRUE) {
#line 256 "../src/game.vala"
				if (!_tmp24_) {
#line 1191 "game.c"
					gint _tmp25_;
#line 256 "../src/game.vala"
					i = i + 1;
#line 256 "../src/game.vala"
					_tmp25_ = i;
#line 1197 "game.c"
				}
#line 256 "../src/game.vala"
				_tmp24_ = FALSE;
#line 256 "../src/game.vala"
				if (!(i < num_robots2)) {
#line 256 "../src/game.vala"
					break;
#line 1205 "game.c"
				}
#line 257 "../src/game.vala"
				game_place_randomly (self, OBJECT_TYPE_ROBOT2);
#line 1209 "game.c"
			}
		}
	}
}

static void
game_place_randomly (Game* self,
                     ObjectType obj)
{
	gint rand_x = 0;
	GRand* _tmp0_;
	Arena* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint rand_y = 0;
	GRand* _tmp4_;
	Arena* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
#line 261 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 262 "../src/game.vala"
	_tmp0_ = self->priv->rand;
#line 262 "../src/game.vala"
	_tmp1_ = self->priv->_arena;
#line 262 "../src/game.vala"
	_tmp2_ = arena_get_width (_tmp1_);
#line 262 "../src/game.vala"
	_tmp3_ = _tmp2_;
#line 262 "../src/game.vala"
	rand_x = (gint) g_rand_int_range (_tmp0_, (gint32) 0, (gint32) _tmp3_);
#line 263 "../src/game.vala"
	_tmp4_ = self->priv->rand;
#line 263 "../src/game.vala"
	_tmp5_ = self->priv->_arena;
#line 263 "../src/game.vala"
	_tmp6_ = arena_get_height (_tmp5_);
#line 263 "../src/game.vala"
	_tmp7_ = _tmp6_;
#line 263 "../src/game.vala"
	rand_y = (gint) g_rand_int_range (_tmp4_, (gint32) 0, (gint32) _tmp7_);
#line 1251 "game.c"
	{
		ArenaIterableIterator* _p_it = NULL;
		Arena* _tmp8_;
		ArenaIterable* _tmp9_;
		ArenaIterable* _tmp10_;
		ArenaIterableIterator* _tmp11_;
		ArenaIterableIterator* _tmp12_;
		ArenaCoords* p = NULL;
#line 264 "../src/game.vala"
		_tmp8_ = self->priv->_arena;
#line 264 "../src/game.vala"
		_tmp9_ = arena_iterate_from (_tmp8_, rand_x, rand_y);
#line 264 "../src/game.vala"
		_tmp10_ = _tmp9_;
#line 264 "../src/game.vala"
		_tmp11_ = arena_iterable_iterator (_tmp10_);
#line 264 "../src/game.vala"
		_tmp12_ = _tmp11_;
#line 264 "../src/game.vala"
		_arena_iterable_unref0 (_tmp10_);
#line 264 "../src/game.vala"
		_p_it = _tmp12_;
#line 264 "../src/game.vala"
		while (TRUE) {
#line 1276 "game.c"
			ArenaIterableIterator* _tmp13_;
			ArenaCoords* _tmp14_;
			ArenaCoords* _tmp15_;
			Arena* _tmp16_;
			ArenaCoords* _tmp17_;
			ArenaCoords* _tmp18_;
#line 264 "../src/game.vala"
			_tmp13_ = _p_it;
#line 264 "../src/game.vala"
			_tmp14_ = arena_iterable_iterator_next_value (_tmp13_);
#line 264 "../src/game.vala"
			_arena_coords_free0 (p);
#line 264 "../src/game.vala"
			p = _tmp14_;
#line 264 "../src/game.vala"
			_tmp15_ = p;
#line 264 "../src/game.vala"
			if (!(_tmp15_ != NULL)) {
#line 264 "../src/game.vala"
				break;
#line 1297 "game.c"
			}
#line 265 "../src/game.vala"
			_tmp16_ = self->priv->_arena;
#line 265 "../src/game.vala"
			_tmp17_ = p;
#line 265 "../src/game.vala"
			_tmp18_ = p;
#line 265 "../src/game.vala"
			if (arena_get (_tmp16_, (*_tmp17_).x, (*_tmp18_).y) == OBJECT_TYPE_NONE) {
#line 1307 "game.c"
				Arena* _tmp19_;
				ArenaCoords* _tmp20_;
				ArenaCoords* _tmp21_;
#line 266 "../src/game.vala"
				_tmp19_ = self->priv->_arena;
#line 266 "../src/game.vala"
				_tmp20_ = p;
#line 266 "../src/game.vala"
				_tmp21_ = p;
#line 266 "../src/game.vala"
				arena_set (_tmp19_, (*_tmp20_).x, (*_tmp21_).y, obj);
#line 267 "../src/game.vala"
				_arena_coords_free0 (p);
#line 267 "../src/game.vala"
				_arena_iterable_iterator_unref0 (_p_it);
#line 267 "../src/game.vala"
				return;
#line 1325 "game.c"
			}
		}
#line 264 "../src/game.vala"
		_arena_coords_free0 (p);
#line 264 "../src/game.vala"
		_arena_iterable_iterator_unref0 (_p_it);
#line 1332 "game.c"
	}
}

static gboolean
___lambda14_ (Game* self,
              ObjectType obj)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 299 "../src/game.vala"
	if (obj == OBJECT_TYPE_ROBOT1) {
#line 299 "../src/game.vala"
		_tmp0_ = TRUE;
#line 1346 "game.c"
	} else {
#line 299 "../src/game.vala"
		_tmp0_ = obj == OBJECT_TYPE_ROBOT2;
#line 1350 "game.c"
	}
#line 299 "../src/game.vala"
	result = _tmp0_;
#line 299 "../src/game.vala"
	return result;
#line 1356 "game.c"
}

static gboolean
____lambda14__gee_predicate (gconstpointer g,
                             gpointer self)
{
	gboolean result;
	result = ___lambda14_ ((Game*) self, (ObjectType) ((gintptr) g));
#line 299 "../src/game.vala"
	return result;
#line 1367 "game.c"
}

static void
game_update_arena (Game* self,
                   GameArenaChange* change)
{
	GameArenaChange _tmp0_;
	ArenaCoords* _tmp1_;
	GameArenaChange _tmp13_;
	ArenaCoords _tmp14_;
	GameArenaChange _tmp15_;
	Arena* _tmp16_;
	Arena* _tmp17_;
	ArenaCoords _tmp18_;
	ArenaCoords _tmp19_;
#line 272 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 272 "../src/game.vala"
	g_return_if_fail (change != NULL);
#line 273 "../src/game.vala"
	_tmp0_ = *change;
#line 273 "../src/game.vala"
	_tmp1_ = _tmp0_.push;
#line 273 "../src/game.vala"
	if (_tmp1_ != NULL) {
#line 1393 "game.c"
		Arena* _tmp2_;
		GameArenaChange _tmp3_;
		ArenaCoords* _tmp4_;
		GameArenaChange _tmp5_;
		ArenaCoords* _tmp6_;
#line 274 "../src/game.vala"
		_tmp2_ = self->priv->_arena;
#line 274 "../src/game.vala"
		_tmp3_ = *change;
#line 274 "../src/game.vala"
		_tmp4_ = _tmp3_.push;
#line 274 "../src/game.vala"
		_tmp5_ = *change;
#line 274 "../src/game.vala"
		_tmp6_ = _tmp5_.push;
#line 274 "../src/game.vala"
		switch (arena_get (_tmp2_, (*_tmp4_).x, (*_tmp6_).y)) {
#line 274 "../src/game.vala"
			case OBJECT_TYPE_ROBOT1:
#line 1413 "game.c"
			{
				GameArenaChange _tmp7_;
				ArenaCoords* _tmp8_;
				GameConfig _tmp9_;
#line 276 "../src/game.vala"
				_tmp7_ = *change;
#line 276 "../src/game.vala"
				_tmp8_ = _tmp7_.push;
#line 276 "../src/game.vala"
				game_set_splat (self, _tmp8_);
#line 277 "../src/game.vala"
				g_signal_emit (self, game_signals[GAME_GAME_EVENT_SIGNAL], 0, GAME_EVENT_SPLAT, 0);
#line 278 "../src/game.vala"
				_tmp9_ = self->priv->_config;
#line 278 "../src/game.vala"
				self->priv->score = self->priv->score + _tmp9_.score_type1_splatted;
#line 279 "../src/game.vala"
				break;
#line 1432 "game.c"
			}
#line 274 "../src/game.vala"
			case OBJECT_TYPE_ROBOT2:
#line 1436 "game.c"
			{
				GameArenaChange _tmp10_;
				ArenaCoords* _tmp11_;
				GameConfig _tmp12_;
#line 281 "../src/game.vala"
				_tmp10_ = *change;
#line 281 "../src/game.vala"
				_tmp11_ = _tmp10_.push;
#line 281 "../src/game.vala"
				game_set_splat (self, _tmp11_);
#line 282 "../src/game.vala"
				g_signal_emit (self, game_signals[GAME_GAME_EVENT_SIGNAL], 0, GAME_EVENT_SPLAT, 0);
#line 283 "../src/game.vala"
				_tmp12_ = self->priv->_config;
#line 283 "../src/game.vala"
				self->priv->score = self->priv->score + _tmp12_.score_type2_splatted;
#line 284 "../src/game.vala"
				break;
#line 1455 "game.c"
			}
			default:
			{
#line 286 "../src/game.vala"
				break;
#line 1461 "game.c"
			}
		}
	}
#line 290 "../src/game.vala"
	_tmp13_ = *change;
#line 290 "../src/game.vala"
	_tmp14_ = _tmp13_.player;
#line 290 "../src/game.vala"
	game_set_player (self, &_tmp14_);
#line 291 "../src/game.vala"
	_tmp15_ = *change;
#line 291 "../src/game.vala"
	_tmp16_ = _tmp15_.arena;
#line 291 "../src/game.vala"
	game_set_arena (self, _tmp16_);
#line 293 "../src/game.vala"
	_tmp17_ = self->priv->_arena;
#line 293 "../src/game.vala"
	_tmp18_ = self->priv->_player;
#line 293 "../src/game.vala"
	_tmp19_ = self->priv->_player;
#line 293 "../src/game.vala"
	if (arena_get (_tmp17_, _tmp18_.x, _tmp19_.y) != OBJECT_TYPE_PLAYER) {
#line 294 "../src/game.vala"
		game_kill_player (self);
#line 1487 "game.c"
	} else {
		Arena* _tmp20_;
#line 299 "../src/game.vala"
		_tmp20_ = self->priv->_arena;
#line 299 "../src/game.vala"
		if (arena_count (_tmp20_, ____lambda14__gee_predicate, self) <= 0) {
#line 300 "../src/game.vala"
			game_set_state (self, GAME_STATE_COMPLETE);
#line 301 "../src/game.vala"
			g_signal_emit (self, game_signals[GAME_GAME_EVENT_SIGNAL], 0, GAME_EVENT_LEVEL_COMPLETE, 0);
#line 302 "../src/game.vala"
			self->priv->endlev_counter = 0;
#line 1500 "game.c"
		}
	}
}

static gpointer
_arena_ref0 (gpointer self)
{
#line 310 "../src/game.vala"
	return self ? arena_ref (self) : NULL;
#line 1510 "game.c"
}

void
game_tick (Game* self)
{
	gboolean _tmp0_ = FALSE;
	GameState _tmp1_;
#line 307 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 308 "../src/game.vala"
	_tmp1_ = self->priv->_state;
#line 308 "../src/game.vala"
	if (_tmp1_ == GAME_STATE_TYPE2) {
#line 308 "../src/game.vala"
		_tmp0_ = TRUE;
#line 1526 "game.c"
	} else {
		GameState _tmp2_;
#line 308 "../src/game.vala"
		_tmp2_ = self->priv->_state;
#line 308 "../src/game.vala"
		_tmp0_ = _tmp2_ == GAME_STATE_WAITING_TYPE2;
#line 1533 "game.c"
	}
#line 308 "../src/game.vala"
	if (_tmp0_) {
#line 1537 "game.c"
		Arena* new_arena = NULL;
		Arena* _tmp3_;
		GameArenaChange change = {0};
		Arena* _tmp4_;
		Arena* _tmp5_;
		ArenaCoords _tmp6_;
		GameArenaChange _tmp7_ = {0};
		GameArenaChange _tmp8_;
		GameState _tmp9_;
#line 309 "../src/game.vala"
		_tmp3_ = game_move_type2_robots (self);
#line 309 "../src/game.vala"
		new_arena = _tmp3_;
#line 310 "../src/game.vala"
		_tmp4_ = new_arena;
#line 310 "../src/game.vala"
		_tmp5_ = _arena_ref0 (_tmp4_);
#line 310 "../src/game.vala"
		_tmp6_ = self->priv->_player;
#line 310 "../src/game.vala"
		memset (&_tmp7_, 0, sizeof (GameArenaChange));
#line 310 "../src/game.vala"
		_arena_unref0 (_tmp7_.arena);
#line 310 "../src/game.vala"
		_tmp7_.arena = _tmp5_;
#line 310 "../src/game.vala"
		_tmp7_.player = _tmp6_;
#line 310 "../src/game.vala"
		_arena_coords_free0 (_tmp7_.push);
#line 310 "../src/game.vala"
		_tmp7_.push = NULL;
#line 310 "../src/game.vala"
		change = _tmp7_;
#line 315 "../src/game.vala"
		_tmp8_ = change;
#line 315 "../src/game.vala"
		game_update_arena (self, &_tmp8_);
#line 316 "../src/game.vala"
		_tmp9_ = self->priv->_state;
#line 316 "../src/game.vala"
		if (_tmp9_ == GAME_STATE_TYPE2) {
#line 317 "../src/game.vala"
			game_set_state (self, GAME_STATE_PLAYING);
#line 1581 "game.c"
		} else {
			GameState _tmp10_;
#line 318 "../src/game.vala"
			_tmp10_ = self->priv->_state;
#line 318 "../src/game.vala"
			if (_tmp10_ == GAME_STATE_WAITING_TYPE2) {
#line 319 "../src/game.vala"
				game_set_state (self, GAME_STATE_WAITING);
#line 1590 "game.c"
			}
		}
#line 308 "../src/game.vala"
		game_arena_change_destroy (&change);
#line 308 "../src/game.vala"
		_arena_unref0 (new_arena);
#line 1597 "game.c"
	} else {
		GameState _tmp11_;
#line 321 "../src/game.vala"
		_tmp11_ = self->priv->_state;
#line 321 "../src/game.vala"
		if (_tmp11_ == GAME_STATE_WAITING) {
#line 322 "../src/game.vala"
			game_set_splat (self, NULL);
#line 323 "../src/game.vala"
			game_move_robots (self);
#line 1608 "game.c"
		} else {
			GameState _tmp12_;
#line 324 "../src/game.vala"
			_tmp12_ = self->priv->_state;
#line 324 "../src/game.vala"
			if (_tmp12_ == GAME_STATE_COMPLETE) {
#line 1615 "game.c"
				gint _tmp13_;
#line 325 "../src/game.vala"
				self->priv->endlev_counter = self->priv->endlev_counter + 1;
#line 325 "../src/game.vala"
				_tmp13_ = self->priv->endlev_counter;
#line 326 "../src/game.vala"
				if (self->priv->endlev_counter >= GAME_CHANGE_DELAY) {
#line 1623 "game.c"
					gint _tmp14_;
#line 327 "../src/game.vala"
					self->priv->current_level = self->priv->current_level + 1;
#line 327 "../src/game.vala"
					_tmp14_ = self->priv->current_level;
#line 328 "../src/game.vala"
					game_generate_level (self);
#line 329 "../src/game.vala"
					game_set_state (self, GAME_STATE_PLAYING);
#line 330 "../src/game.vala"
					game_set_splat (self, NULL);
#line 1635 "game.c"
				}
			} else {
				GameState _tmp15_;
#line 332 "../src/game.vala"
				_tmp15_ = self->priv->_state;
#line 332 "../src/game.vala"
				if (_tmp15_ == GAME_STATE_DEAD) {
#line 1643 "game.c"
					gint _tmp16_;
#line 333 "../src/game.vala"
					self->priv->endlev_counter = self->priv->endlev_counter + 1;
#line 333 "../src/game.vala"
					_tmp16_ = self->priv->endlev_counter;
#line 334 "../src/game.vala"
					if (self->priv->endlev_counter >= GAME_DEAD_DELAY) {
#line 335 "../src/game.vala"
						if (self->priv->score > 0) {
#line 336 "../src/game.vala"
							g_signal_emit (self, game_signals[GAME_GAME_EVENT_SIGNAL], 0, GAME_EVENT_SCORED, self->priv->score);
#line 1655 "game.c"
						}
#line 338 "../src/game.vala"
						game_start_new_game (self);
#line 1659 "game.c"
					}
				}
			}
		}
	}
}

/**
     * Initialises everything needed to start a new game
     **/
void
game_start_new_game (Game* self)
{
	GameConfig _tmp0_;
#line 346 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 347 "../src/game.vala"
	self->priv->current_level = 0;
#line 348 "../src/game.vala"
	self->priv->score = 0;
#line 349 "../src/game.vala"
	self->priv->kills = 0;
#line 350 "../src/game.vala"
	self->priv->score_step = 0;
#line 352 "../src/game.vala"
	_tmp0_ = self->priv->_config;
#line 352 "../src/game.vala"
	self->priv->safe_teleports = _tmp0_.initial_safe_teleports;
#line 354 "../src/game.vala"
	game_set_splat (self, NULL);
#line 355 "../src/game.vala"
	game_generate_level (self);
#line 357 "../src/game.vala"
	game_set_state (self, GAME_STATE_PLAYING);
#line 1694 "game.c"
}

/**
     * Moves all of the robots and checks for collisions
     **/
static gboolean
__lambda18_ (Game* self,
             ObjectType obj)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 365 "../src/game.vala"
	if (obj == OBJECT_TYPE_ROBOT1) {
#line 365 "../src/game.vala"
		_tmp0_ = TRUE;
#line 1710 "game.c"
	} else {
#line 366 "../src/game.vala"
		_tmp0_ = obj == OBJECT_TYPE_ROBOT2;
#line 1714 "game.c"
	}
#line 365 "../src/game.vala"
	result = _tmp0_;
#line 365 "../src/game.vala"
	return result;
#line 1720 "game.c"
}

static gboolean
___lambda18__gee_predicate (gconstpointer g,
                            gpointer self)
{
	gboolean result;
	result = __lambda18_ ((Game*) self, (ObjectType) ((gintptr) g));
#line 364 "../src/game.vala"
	return result;
#line 1731 "game.c"
}

static void
__lambda19_ (Game* self,
             ObjectType victim)
{
#line 369 "../src/game.vala"
	game_add_kill (self, victim);
#line 1740 "game.c"
}

static void
___lambda19__game_kill_tracker (ObjectType victim,
                                gpointer self)
{
#line 364 "../src/game.vala"
	__lambda19_ ((Game*) self, victim);
#line 1749 "game.c"
}

static Arena*
game_move_all_robots (Game* self)
{
	Arena* _tmp0_;
	ArenaCoords _tmp1_;
	ArenaCoords _tmp2_;
	Arena* _tmp3_;
	Arena* result;
#line 363 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 364 "../src/game.vala"
	_tmp0_ = self->priv->_arena;
#line 364 "../src/game.vala"
	_tmp1_ = self->priv->_player;
#line 364 "../src/game.vala"
	_tmp2_ = self->priv->_player;
#line 364 "../src/game.vala"
	_tmp3_ = game_chase (_tmp0_, ___lambda18__gee_predicate, self, _tmp1_.x, _tmp2_.y, ___lambda19__game_kill_tracker, self);
#line 364 "../src/game.vala"
	result = _tmp3_;
#line 364 "../src/game.vala"
	return result;
#line 1774 "game.c"
}

/**
     * Makes the extra move for all of the type2 robots
     **/
static gboolean
__lambda16_ (Game* self,
             ObjectType obj)
{
	gboolean result;
#line 377 "../src/game.vala"
	result = obj == OBJECT_TYPE_ROBOT2;
#line 377 "../src/game.vala"
	return result;
#line 1789 "game.c"
}

static gboolean
___lambda16__gee_predicate (gconstpointer g,
                            gpointer self)
{
	gboolean result;
	result = __lambda16_ ((Game*) self, (ObjectType) ((gintptr) g));
#line 376 "../src/game.vala"
	return result;
#line 1800 "game.c"
}

static void
__lambda17_ (Game* self,
             ObjectType victim)
{
#line 380 "../src/game.vala"
	game_add_kill (self, victim);
#line 1809 "game.c"
}

static void
___lambda17__game_kill_tracker (ObjectType victim,
                                gpointer self)
{
#line 376 "../src/game.vala"
	__lambda17_ ((Game*) self, victim);
#line 1818 "game.c"
}

static Arena*
game_move_type2_robots (Game* self)
{
	Arena* _tmp0_;
	ArenaCoords _tmp1_;
	ArenaCoords _tmp2_;
	Arena* _tmp3_;
	Arena* result;
#line 375 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 376 "../src/game.vala"
	_tmp0_ = self->priv->_arena;
#line 376 "../src/game.vala"
	_tmp1_ = self->priv->_player;
#line 376 "../src/game.vala"
	_tmp2_ = self->priv->_player;
#line 376 "../src/game.vala"
	_tmp3_ = game_chase (_tmp0_, ___lambda16__gee_predicate, self, _tmp1_.x, _tmp2_.y, ___lambda17__game_kill_tracker, self);
#line 376 "../src/game.vala"
	result = _tmp3_;
#line 376 "../src/game.vala"
	return result;
#line 1843 "game.c"
}

/**
     * Starts the process of moving robots
     **/
static gboolean
__lambda20_ (Game* self,
             ObjectType obj)
{
	gboolean result;
#line 389 "../src/game.vala"
	result = obj == OBJECT_TYPE_ROBOT2;
#line 389 "../src/game.vala"
	return result;
#line 1858 "game.c"
}

static gboolean
___lambda20__gee_predicate (gconstpointer g,
                            gpointer self)
{
	gboolean result;
	result = __lambda20_ ((Game*) self, (ObjectType) ((gintptr) g));
#line 389 "../src/game.vala"
	return result;
#line 1869 "game.c"
}

static void
game_move_robots (Game* self)
{
	Arena* new_arena = NULL;
	Arena* _tmp0_;
	gint num_robots2 = 0;
	Arena* _tmp1_;
	GameArenaChange change = {0};
	Arena* _tmp4_;
	Arena* _tmp5_;
	ArenaCoords _tmp6_;
	GameArenaChange _tmp7_ = {0};
	GameArenaChange _tmp8_;
#line 386 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 387 "../src/game.vala"
	_tmp0_ = game_move_all_robots (self);
#line 387 "../src/game.vala"
	new_arena = _tmp0_;
#line 389 "../src/game.vala"
	_tmp1_ = new_arena;
#line 389 "../src/game.vala"
	num_robots2 = arena_count (_tmp1_, ___lambda20__gee_predicate, self);
#line 390 "../src/game.vala"
	if (num_robots2 > 0) {
#line 1897 "game.c"
		GameState _tmp2_;
#line 391 "../src/game.vala"
		_tmp2_ = self->priv->_state;
#line 391 "../src/game.vala"
		if (_tmp2_ == GAME_STATE_WAITING) {
#line 392 "../src/game.vala"
			game_set_state (self, GAME_STATE_WAITING_TYPE2);
#line 1905 "game.c"
		} else {
			GameState _tmp3_;
#line 393 "../src/game.vala"
			_tmp3_ = self->priv->_state;
#line 393 "../src/game.vala"
			if (_tmp3_ == GAME_STATE_PLAYING) {
#line 394 "../src/game.vala"
				game_set_state (self, GAME_STATE_TYPE2);
#line 1914 "game.c"
			}
		}
	}
#line 398 "../src/game.vala"
	_tmp4_ = new_arena;
#line 398 "../src/game.vala"
	_tmp5_ = _arena_ref0 (_tmp4_);
#line 398 "../src/game.vala"
	_tmp6_ = self->priv->_player;
#line 398 "../src/game.vala"
	memset (&_tmp7_, 0, sizeof (GameArenaChange));
#line 398 "../src/game.vala"
	_arena_unref0 (_tmp7_.arena);
#line 398 "../src/game.vala"
	_tmp7_.arena = _tmp5_;
#line 398 "../src/game.vala"
	_tmp7_.player = _tmp6_;
#line 398 "../src/game.vala"
	_arena_coords_free0 (_tmp7_.push);
#line 398 "../src/game.vala"
	_tmp7_.push = NULL;
#line 398 "../src/game.vala"
	change = _tmp7_;
#line 404 "../src/game.vala"
	_tmp8_ = change;
#line 404 "../src/game.vala"
	game_update_arena (self, &_tmp8_);
#line 386 "../src/game.vala"
	game_arena_change_destroy (&change);
#line 386 "../src/game.vala"
	_arena_unref0 (new_arena);
#line 1946 "game.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 409 "../src/game.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 409 "../src/game.vala"
	return _data4_;
#line 1956 "game.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 409 "../src/game.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 409 "../src/game.vala"
		g_slice_free (Block4Data, _data4_);
#line 1968 "game.c"
	}
}

static ObjectType
__lambda15_ (Block4Data* _data4_,
             ObjectType obj)
{
	gboolean _tmp0_ = FALSE;
	ObjectType result;
#line 411 "../src/game.vala"
	if (obj == OBJECT_TYPE_PLAYER) {
#line 411 "../src/game.vala"
		_tmp0_ = TRUE;
#line 1982 "game.c"
	} else {
#line 411 "../src/game.vala"
		_tmp0_ = _data4_->is_chaser ((gpointer) ((gintptr) obj), _data4_->is_chaser_target);
#line 1986 "game.c"
	}
#line 411 "../src/game.vala"
	if (_tmp0_) {
#line 412 "../src/game.vala"
		result = OBJECT_TYPE_NONE;
#line 412 "../src/game.vala"
		return result;
#line 1994 "game.c"
	} else {
#line 414 "../src/game.vala"
		result = obj;
#line 414 "../src/game.vala"
		return result;
#line 2000 "game.c"
	}
}

static ObjectType
___lambda15__arena_mapper (ObjectType obj,
                           gpointer self)
{
	ObjectType result;
	result = __lambda15_ (self, obj);
#line 410 "../src/game.vala"
	return result;
#line 2012 "game.c"
}

static Arena*
game_chase (Arena* arena,
            GeePredicate is_chaser,
            gpointer is_chaser_target,
            gint x,
            gint y,
            GameKillTracker track_kill,
            gpointer track_kill_target)
{
	Block4Data* _data4_;
	Arena* new_arena = NULL;
	Arena* _tmp0_;
	Arena* _tmp13_;
	Arena* result;
#line 409 "../src/game.vala"
	g_return_val_if_fail (arena != NULL, NULL);
#line 409 "../src/game.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 409 "../src/game.vala"
	_data4_->_ref_count_ = 1;
#line 409 "../src/game.vala"
	_data4_->is_chaser = is_chaser;
#line 409 "../src/game.vala"
	_data4_->is_chaser_target = is_chaser_target;
#line 410 "../src/game.vala"
	_tmp0_ = arena_map (arena, ___lambda15__arena_mapper, _data4_);
#line 410 "../src/game.vala"
	new_arena = _tmp0_;
#line 2043 "game.c"
	{
		gint i = 0;
#line 418 "../src/game.vala"
		i = 0;
#line 2048 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 418 "../src/game.vala"
			_tmp1_ = TRUE;
#line 418 "../src/game.vala"
			while (TRUE) {
#line 2055 "game.c"
				gint _tmp3_;
				gint _tmp4_;
#line 418 "../src/game.vala"
				if (!_tmp1_) {
#line 2060 "game.c"
					gint _tmp2_;
#line 418 "../src/game.vala"
					i = i + 1;
#line 418 "../src/game.vala"
					_tmp2_ = i;
#line 2066 "game.c"
				}
#line 418 "../src/game.vala"
				_tmp1_ = FALSE;
#line 418 "../src/game.vala"
				_tmp3_ = arena_get_width (arena);
#line 418 "../src/game.vala"
				_tmp4_ = _tmp3_;
#line 418 "../src/game.vala"
				if (!(i < _tmp4_)) {
#line 418 "../src/game.vala"
					break;
#line 2078 "game.c"
				}
				{
					gint j = 0;
#line 419 "../src/game.vala"
					j = 0;
#line 2084 "game.c"
					{
						gboolean _tmp5_ = FALSE;
#line 419 "../src/game.vala"
						_tmp5_ = TRUE;
#line 419 "../src/game.vala"
						while (TRUE) {
#line 2091 "game.c"
							gint _tmp7_;
							gint _tmp8_;
							ObjectType who = 0;
#line 419 "../src/game.vala"
							if (!_tmp5_) {
#line 2097 "game.c"
								gint _tmp6_;
#line 419 "../src/game.vala"
								j = j + 1;
#line 419 "../src/game.vala"
								_tmp6_ = j;
#line 2103 "game.c"
							}
#line 419 "../src/game.vala"
							_tmp5_ = FALSE;
#line 419 "../src/game.vala"
							_tmp7_ = arena_get_height (arena);
#line 419 "../src/game.vala"
							_tmp8_ = _tmp7_;
#line 419 "../src/game.vala"
							if (!(j < _tmp8_)) {
#line 419 "../src/game.vala"
								break;
#line 2115 "game.c"
							}
#line 420 "../src/game.vala"
							who = arena_get (arena, i, j);
#line 421 "../src/game.vala"
							if (_data4_->is_chaser ((gpointer) ((gintptr) who), _data4_->is_chaser_target)) {
#line 2121 "game.c"
								gint nx = 0;
								gint ny = 0;
								ObjectType destination = 0;
								Arena* _tmp9_;
#line 422 "../src/game.vala"
								nx = i;
#line 423 "../src/game.vala"
								ny = j;
#line 424 "../src/game.vala"
								if (x < nx) {
#line 425 "../src/game.vala"
									nx -= 1;
#line 2134 "game.c"
								}
#line 426 "../src/game.vala"
								if (x > nx) {
#line 427 "../src/game.vala"
									nx += 1;
#line 2140 "game.c"
								}
#line 428 "../src/game.vala"
								if (y < ny) {
#line 429 "../src/game.vala"
									ny -= 1;
#line 2146 "game.c"
								}
#line 430 "../src/game.vala"
								if (y > ny) {
#line 431 "../src/game.vala"
									ny += 1;
#line 2152 "game.c"
								}
#line 433 "../src/game.vala"
								_tmp9_ = new_arena;
#line 433 "../src/game.vala"
								destination = arena_get (_tmp9_, nx, ny);
#line 434 "../src/game.vala"
								if (destination == OBJECT_TYPE_HEAP) {
#line 435 "../src/game.vala"
									if (track_kill != NULL) {
#line 436 "../src/game.vala"
										track_kill (who, track_kill_target);
#line 2164 "game.c"
									}
								} else {
									gboolean _tmp10_ = FALSE;
#line 438 "../src/game.vala"
									if (destination == OBJECT_TYPE_ROBOT1) {
#line 438 "../src/game.vala"
										_tmp10_ = TRUE;
#line 2172 "game.c"
									} else {
#line 439 "../src/game.vala"
										_tmp10_ = destination == OBJECT_TYPE_ROBOT2;
#line 2176 "game.c"
									}
#line 438 "../src/game.vala"
									if (_tmp10_) {
#line 2180 "game.c"
										Arena* _tmp11_;
#line 441 "../src/game.vala"
										if (track_kill != NULL) {
#line 442 "../src/game.vala"
											track_kill (who, track_kill_target);
#line 443 "../src/game.vala"
											track_kill (destination, track_kill_target);
#line 2188 "game.c"
										}
#line 445 "../src/game.vala"
										_tmp11_ = new_arena;
#line 445 "../src/game.vala"
										arena_set (_tmp11_, nx, ny, OBJECT_TYPE_HEAP);
#line 2194 "game.c"
									} else {
										Arena* _tmp12_;
#line 447 "../src/game.vala"
										_tmp12_ = new_arena;
#line 447 "../src/game.vala"
										arena_set (_tmp12_, nx, ny, who);
#line 2201 "game.c"
									}
								}
							}
						}
					}
				}
			}
		}
	}
#line 453 "../src/game.vala"
	_tmp13_ = new_arena;
#line 453 "../src/game.vala"
	if (arena_get (_tmp13_, x, y) == OBJECT_TYPE_NONE) {
#line 2215 "game.c"
		Arena* _tmp14_;
#line 454 "../src/game.vala"
		_tmp14_ = new_arena;
#line 454 "../src/game.vala"
		arena_set (_tmp14_, x, y, OBJECT_TYPE_PLAYER);
#line 2221 "game.c"
	}
#line 457 "../src/game.vala"
	result = new_arena;
#line 457 "../src/game.vala"
	block4_data_unref (_data4_);
#line 457 "../src/game.vala"
	_data4_ = NULL;
#line 457 "../src/game.vala"
	return result;
#line 2231 "game.c"
}

/**
     * checks whether a given location is safe
     **/
static gboolean
__lambda21_ (Game* self,
             ObjectType obj)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 465 "../src/game.vala"
	if (obj == OBJECT_TYPE_ROBOT1) {
#line 465 "../src/game.vala"
		_tmp0_ = TRUE;
#line 2247 "game.c"
	} else {
#line 466 "../src/game.vala"
		_tmp0_ = obj == OBJECT_TYPE_ROBOT2;
#line 2251 "game.c"
	}
#line 465 "../src/game.vala"
	result = _tmp0_;
#line 465 "../src/game.vala"
	return result;
#line 2257 "game.c"
}

static gboolean
___lambda21__gee_predicate (gconstpointer g,
                            gpointer self)
{
	gboolean result;
	result = __lambda21_ ((Game*) self, (ObjectType) ((gintptr) g));
#line 464 "../src/game.vala"
	return result;
#line 2268 "game.c"
}

static gboolean
__lambda22_ (Game* self,
             ObjectType obj)
{
	gboolean result;
#line 476 "../src/game.vala"
	result = obj == OBJECT_TYPE_ROBOT2;
#line 476 "../src/game.vala"
	return result;
#line 2280 "game.c"
}

static gboolean
___lambda22__gee_predicate (gconstpointer g,
                            gpointer self)
{
	gboolean result;
	result = __lambda22_ ((Game*) self, (ObjectType) ((gintptr) g));
#line 475 "../src/game.vala"
	return result;
#line 2291 "game.c"
}

static gboolean
game_check_safe (Game* self,
                 GameArenaChange* change)
{
	Arena* temp2_arena = NULL;
	GameArenaChange _tmp0_;
	Arena* _tmp1_;
	GameArenaChange _tmp2_;
	ArenaCoords _tmp3_;
	GameArenaChange _tmp4_;
	ArenaCoords _tmp5_;
	Arena* _tmp6_;
	Arena* _tmp7_;
	GameArenaChange _tmp8_;
	ArenaCoords _tmp9_;
	GameArenaChange _tmp10_;
	ArenaCoords _tmp11_;
	Arena* temp3_arena = NULL;
	Arena* _tmp12_;
	GameArenaChange _tmp13_;
	ArenaCoords _tmp14_;
	GameArenaChange _tmp15_;
	ArenaCoords _tmp16_;
	Arena* _tmp17_;
	Arena* _tmp18_;
	GameArenaChange _tmp19_;
	ArenaCoords _tmp20_;
	GameArenaChange _tmp21_;
	ArenaCoords _tmp22_;
	gboolean result;
#line 463 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 463 "../src/game.vala"
	g_return_val_if_fail (change != NULL, FALSE);
#line 464 "../src/game.vala"
	_tmp0_ = *change;
#line 464 "../src/game.vala"
	_tmp1_ = _tmp0_.arena;
#line 464 "../src/game.vala"
	_tmp2_ = *change;
#line 464 "../src/game.vala"
	_tmp3_ = _tmp2_.player;
#line 464 "../src/game.vala"
	_tmp4_ = *change;
#line 464 "../src/game.vala"
	_tmp5_ = _tmp4_.player;
#line 464 "../src/game.vala"
	_tmp6_ = game_chase (_tmp1_, ___lambda21__gee_predicate, self, _tmp3_.x, _tmp5_.y, NULL, NULL);
#line 464 "../src/game.vala"
	temp2_arena = _tmp6_;
#line 471 "../src/game.vala"
	_tmp7_ = temp2_arena;
#line 471 "../src/game.vala"
	_tmp8_ = *change;
#line 471 "../src/game.vala"
	_tmp9_ = _tmp8_.player;
#line 471 "../src/game.vala"
	_tmp10_ = *change;
#line 471 "../src/game.vala"
	_tmp11_ = _tmp10_.player;
#line 471 "../src/game.vala"
	if (arena_get (_tmp7_, _tmp9_.x, _tmp11_.y) != OBJECT_TYPE_PLAYER) {
#line 472 "../src/game.vala"
		result = FALSE;
#line 472 "../src/game.vala"
		_arena_unref0 (temp2_arena);
#line 472 "../src/game.vala"
		return result;
#line 2362 "game.c"
	}
#line 475 "../src/game.vala"
	_tmp12_ = temp2_arena;
#line 475 "../src/game.vala"
	_tmp13_ = *change;
#line 475 "../src/game.vala"
	_tmp14_ = _tmp13_.player;
#line 475 "../src/game.vala"
	_tmp15_ = *change;
#line 475 "../src/game.vala"
	_tmp16_ = _tmp15_.player;
#line 475 "../src/game.vala"
	_tmp17_ = game_chase (_tmp12_, ___lambda22__gee_predicate, self, _tmp14_.x, _tmp16_.y, NULL, NULL);
#line 475 "../src/game.vala"
	temp3_arena = _tmp17_;
#line 481 "../src/game.vala"
	_tmp18_ = temp3_arena;
#line 481 "../src/game.vala"
	_tmp19_ = *change;
#line 481 "../src/game.vala"
	_tmp20_ = _tmp19_.player;
#line 481 "../src/game.vala"
	_tmp21_ = *change;
#line 481 "../src/game.vala"
	_tmp22_ = _tmp21_.player;
#line 481 "../src/game.vala"
	if (arena_get (_tmp18_, _tmp20_.x, _tmp22_.y) != OBJECT_TYPE_PLAYER) {
#line 482 "../src/game.vala"
		result = FALSE;
#line 482 "../src/game.vala"
		_arena_unref0 (temp3_arena);
#line 482 "../src/game.vala"
		_arena_unref0 (temp2_arena);
#line 482 "../src/game.vala"
		return result;
#line 2398 "game.c"
	}
#line 485 "../src/game.vala"
	result = TRUE;
#line 485 "../src/game.vala"
	_arena_unref0 (temp3_arena);
#line 485 "../src/game.vala"
	_arena_unref0 (temp2_arena);
#line 485 "../src/game.vala"
	return result;
#line 2408 "game.c"
}

static ObjectType
__lambda23_ (Game* self,
             ObjectType obj)
{
	ObjectType result;
#line 508 "../src/game.vala"
	if (obj != OBJECT_TYPE_PLAYER) {
#line 509 "../src/game.vala"
		result = obj;
#line 509 "../src/game.vala"
		return result;
#line 2422 "game.c"
	} else {
#line 511 "../src/game.vala"
		result = OBJECT_TYPE_NONE;
#line 511 "../src/game.vala"
		return result;
#line 2428 "game.c"
	}
}

static ObjectType
___lambda23__arena_mapper (ObjectType obj,
                           gpointer self)
{
	ObjectType result;
	result = __lambda23_ ((Game*) self, obj);
#line 507 "../src/game.vala"
	return result;
#line 2440 "game.c"
}

static gpointer
_arena_coords_dup0 (gpointer self)
{
#line 516 "../src/game.vala"
	return self ? arena_coords_dup (self) : NULL;
#line 2448 "game.c"
}

static gpointer
_game_arena_change_dup0 (gpointer self)
{
#line 516 "../src/game.vala"
	return self ? game_arena_change_dup (self) : NULL;
#line 2456 "game.c"
}

static GameArenaChange*
game_try_push_heap (Game* self,
                    gint dx,
                    gint dy)
{
	GameConfig _tmp0_;
	ArenaCoords coords = {0};
	ArenaCoords _tmp1_;
	ArenaCoords _tmp2_ = {0};
	gboolean _tmp3_ = FALSE;
	Arena* _tmp4_;
	ArenaCoords _tmp5_;
	ArenaCoords push_to = {0};
	ArenaCoords _tmp9_ = {0};
	gboolean _tmp10_ = FALSE;
	Arena* _tmp11_;
	ArenaCoords _tmp12_;
	Arena* new_arena = NULL;
	Arena* _tmp16_;
	Arena* _tmp17_;
	Arena* _tmp18_;
	ArenaCoords _tmp19_;
	ArenaCoords _tmp20_;
	Arena* _tmp21_;
	ArenaCoords _tmp22_;
	ArenaCoords _tmp23_;
	Arena* _tmp24_;
	Arena* _tmp25_;
	ArenaCoords _tmp26_;
	ArenaCoords _tmp27_;
	ArenaCoords* _tmp28_;
	GameArenaChange _tmp29_ = {0};
	GameArenaChange _tmp30_;
	GameArenaChange* _tmp31_;
	GameArenaChange* _tmp32_;
	GameArenaChange* result;
#line 488 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 489 "../src/game.vala"
	_tmp0_ = self->priv->_config;
#line 489 "../src/game.vala"
	if (!_tmp0_.moveable_heaps) {
#line 490 "../src/game.vala"
		result = NULL;
#line 490 "../src/game.vala"
		return result;
#line 2505 "game.c"
	}
#line 493 "../src/game.vala"
	_tmp1_ = self->priv->_player;
#line 493 "../src/game.vala"
	arena_coords_move (&_tmp1_, dx, dy, &_tmp2_);
#line 493 "../src/game.vala"
	coords = _tmp2_;
#line 494 "../src/game.vala"
	_tmp4_ = self->priv->_arena;
#line 494 "../src/game.vala"
	_tmp5_ = coords;
#line 494 "../src/game.vala"
	if (!arena_are_coords_valid (_tmp4_, &_tmp5_)) {
#line 494 "../src/game.vala"
		_tmp3_ = TRUE;
#line 2521 "game.c"
	} else {
		Arena* _tmp6_;
		ArenaCoords _tmp7_;
		ArenaCoords _tmp8_;
#line 495 "../src/game.vala"
		_tmp6_ = self->priv->_arena;
#line 495 "../src/game.vala"
		_tmp7_ = coords;
#line 495 "../src/game.vala"
		_tmp8_ = coords;
#line 495 "../src/game.vala"
		_tmp3_ = arena_get (_tmp6_, _tmp7_.x, _tmp8_.y) != OBJECT_TYPE_HEAP;
#line 2534 "game.c"
	}
#line 494 "../src/game.vala"
	if (_tmp3_) {
#line 497 "../src/game.vala"
		result = NULL;
#line 497 "../src/game.vala"
		return result;
#line 2542 "game.c"
	}
#line 500 "../src/game.vala"
	arena_coords_move (&coords, dx, dy, &_tmp9_);
#line 500 "../src/game.vala"
	push_to = _tmp9_;
#line 501 "../src/game.vala"
	_tmp11_ = self->priv->_arena;
#line 501 "../src/game.vala"
	_tmp12_ = push_to;
#line 501 "../src/game.vala"
	if (!arena_are_coords_valid (_tmp11_, &_tmp12_)) {
#line 501 "../src/game.vala"
		_tmp10_ = TRUE;
#line 2556 "game.c"
	} else {
		Arena* _tmp13_;
		ArenaCoords _tmp14_;
		ArenaCoords _tmp15_;
#line 502 "../src/game.vala"
		_tmp13_ = self->priv->_arena;
#line 502 "../src/game.vala"
		_tmp14_ = push_to;
#line 502 "../src/game.vala"
		_tmp15_ = push_to;
#line 502 "../src/game.vala"
		_tmp10_ = arena_get (_tmp13_, _tmp14_.x, _tmp15_.y) == OBJECT_TYPE_HEAP;
#line 2569 "game.c"
	}
#line 501 "../src/game.vala"
	if (_tmp10_) {
#line 504 "../src/game.vala"
		result = NULL;
#line 504 "../src/game.vala"
		return result;
#line 2577 "game.c"
	}
#line 507 "../src/game.vala"
	_tmp16_ = self->priv->_arena;
#line 507 "../src/game.vala"
	_tmp17_ = arena_map (_tmp16_, ___lambda23__arena_mapper, self);
#line 507 "../src/game.vala"
	new_arena = _tmp17_;
#line 514 "../src/game.vala"
	_tmp18_ = new_arena;
#line 514 "../src/game.vala"
	_tmp19_ = coords;
#line 514 "../src/game.vala"
	_tmp20_ = coords;
#line 514 "../src/game.vala"
	arena_set (_tmp18_, _tmp19_.x, _tmp20_.y, OBJECT_TYPE_PLAYER);
#line 515 "../src/game.vala"
	_tmp21_ = new_arena;
#line 515 "../src/game.vala"
	_tmp22_ = push_to;
#line 515 "../src/game.vala"
	_tmp23_ = push_to;
#line 515 "../src/game.vala"
	arena_set (_tmp21_, _tmp22_.x, _tmp23_.y, OBJECT_TYPE_HEAP);
#line 516 "../src/game.vala"
	_tmp24_ = new_arena;
#line 516 "../src/game.vala"
	_tmp25_ = _arena_ref0 (_tmp24_);
#line 516 "../src/game.vala"
	_tmp26_ = coords;
#line 516 "../src/game.vala"
	_tmp27_ = push_to;
#line 516 "../src/game.vala"
	_tmp28_ = _arena_coords_dup0 (&_tmp27_);
#line 516 "../src/game.vala"
	memset (&_tmp29_, 0, sizeof (GameArenaChange));
#line 516 "../src/game.vala"
	_arena_unref0 (_tmp29_.arena);
#line 516 "../src/game.vala"
	_tmp29_.arena = _tmp25_;
#line 516 "../src/game.vala"
	_tmp29_.player = _tmp26_;
#line 516 "../src/game.vala"
	_arena_coords_free0 (_tmp29_.push);
#line 516 "../src/game.vala"
	_tmp29_.push = _tmp28_;
#line 516 "../src/game.vala"
	_tmp30_ = _tmp29_;
#line 516 "../src/game.vala"
	_tmp31_ = _game_arena_change_dup0 (&_tmp30_);
#line 516 "../src/game.vala"
	_tmp32_ = _tmp31_;
#line 516 "../src/game.vala"
	game_arena_change_destroy (&_tmp30_);
#line 516 "../src/game.vala"
	result = _tmp32_;
#line 516 "../src/game.vala"
	_arena_unref0 (new_arena);
#line 516 "../src/game.vala"
	return result;
#line 2637 "game.c"
}

/**
     * tries to move the player in a given direction
     **/
static GameArenaChange*
game_try_player_move (Game* self,
                      gint dx,
                      gint dy)
{
	ArenaCoords coords = {0};
	ArenaCoords _tmp0_;
	ArenaCoords _tmp1_ = {0};
	Arena* _tmp2_;
	ArenaCoords _tmp3_;
	Arena* _tmp4_;
	ArenaCoords _tmp5_;
	ArenaCoords _tmp6_;
	GameArenaChange* result;
#line 526 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 527 "../src/game.vala"
	_tmp0_ = self->priv->_player;
#line 527 "../src/game.vala"
	arena_coords_move (&_tmp0_, dx, dy, &_tmp1_);
#line 527 "../src/game.vala"
	coords = _tmp1_;
#line 529 "../src/game.vala"
	_tmp2_ = self->priv->_arena;
#line 529 "../src/game.vala"
	_tmp3_ = coords;
#line 529 "../src/game.vala"
	if (!arena_are_coords_valid (_tmp2_, &_tmp3_)) {
#line 530 "../src/game.vala"
		result = NULL;
#line 530 "../src/game.vala"
		return result;
#line 2675 "game.c"
	}
#line 533 "../src/game.vala"
	_tmp4_ = self->priv->_arena;
#line 533 "../src/game.vala"
	_tmp5_ = coords;
#line 533 "../src/game.vala"
	_tmp6_ = coords;
#line 533 "../src/game.vala"
	if (arena_get (_tmp4_, _tmp5_.x, _tmp6_.y) == OBJECT_TYPE_HEAP) {
#line 2685 "game.c"
		GameArenaChange* _tmp7_;
#line 534 "../src/game.vala"
		_tmp7_ = game_try_push_heap (self, dx, dy);
#line 534 "../src/game.vala"
		result = _tmp7_;
#line 534 "../src/game.vala"
		return result;
#line 2693 "game.c"
	} else {
		ArenaCoords _tmp8_;
		GameArenaChange _tmp9_ = {0};
		GameArenaChange _tmp10_;
		GameArenaChange* _tmp11_;
		GameArenaChange* _tmp12_;
#line 536 "../src/game.vala"
		_tmp8_ = coords;
#line 536 "../src/game.vala"
		game_move_player_to (self, &_tmp8_, &_tmp9_);
#line 536 "../src/game.vala"
		_tmp10_ = _tmp9_;
#line 536 "../src/game.vala"
		_tmp11_ = _game_arena_change_dup0 (&_tmp10_);
#line 536 "../src/game.vala"
		_tmp12_ = _tmp11_;
#line 536 "../src/game.vala"
		game_arena_change_destroy (&_tmp10_);
#line 536 "../src/game.vala"
		result = _tmp12_;
#line 536 "../src/game.vala"
		return result;
#line 2716 "game.c"
	}
}

/**
     * safe_move_available
     *
     * Description:
     * checks to see if a safe move was available to the player
     *
     * Returns:
     * TRUE if there is a possible safe move, FALSE otherwise
     **/
static gboolean
game_safe_move_available (Game* self)
{
	gboolean result;
#line 549 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2735 "game.c"
	{
		gint dx = 0;
#line 550 "../src/game.vala"
		dx = -1;
#line 2740 "game.c"
		{
			gboolean _tmp0_ = FALSE;
#line 550 "../src/game.vala"
			_tmp0_ = TRUE;
#line 550 "../src/game.vala"
			while (TRUE) {
#line 550 "../src/game.vala"
				if (!_tmp0_) {
#line 2749 "game.c"
					gint _tmp1_;
#line 550 "../src/game.vala"
					dx = dx + 1;
#line 550 "../src/game.vala"
					_tmp1_ = dx;
#line 2755 "game.c"
				}
#line 550 "../src/game.vala"
				_tmp0_ = FALSE;
#line 550 "../src/game.vala"
				if (!(dx <= 1)) {
#line 550 "../src/game.vala"
					break;
#line 2763 "game.c"
				}
				{
					gint dy = 0;
#line 551 "../src/game.vala"
					dy = -1;
#line 2769 "game.c"
					{
						gboolean _tmp2_ = FALSE;
#line 551 "../src/game.vala"
						_tmp2_ = TRUE;
#line 551 "../src/game.vala"
						while (TRUE) {
#line 2776 "game.c"
							GameArenaChange* change = NULL;
							GameArenaChange* _tmp4_;
							GameArenaChange* _tmp5_;
#line 551 "../src/game.vala"
							if (!_tmp2_) {
#line 2782 "game.c"
								gint _tmp3_;
#line 551 "../src/game.vala"
								dy = dy + 1;
#line 551 "../src/game.vala"
								_tmp3_ = dy;
#line 2788 "game.c"
							}
#line 551 "../src/game.vala"
							_tmp2_ = FALSE;
#line 551 "../src/game.vala"
							if (!(dy <= 1)) {
#line 551 "../src/game.vala"
								break;
#line 2796 "game.c"
							}
#line 552 "../src/game.vala"
							_tmp4_ = game_try_player_move (self, dx, dy);
#line 552 "../src/game.vala"
							change = _tmp4_;
#line 553 "../src/game.vala"
							_tmp5_ = change;
#line 553 "../src/game.vala"
							if (_tmp5_ != NULL) {
#line 2806 "game.c"
								GameArenaChange* _tmp6_;
								GameArenaChange _tmp7_;
#line 554 "../src/game.vala"
								_tmp6_ = change;
#line 554 "../src/game.vala"
								_tmp7_ = *_tmp6_;
#line 554 "../src/game.vala"
								if (game_check_safe (self, &_tmp7_)) {
#line 555 "../src/game.vala"
									result = TRUE;
#line 555 "../src/game.vala"
									_game_arena_change_free0 (change);
#line 555 "../src/game.vala"
									return result;
#line 2821 "game.c"
								}
							}
#line 551 "../src/game.vala"
							_game_arena_change_free0 (change);
#line 2826 "game.c"
						}
					}
				}
			}
		}
	}
#line 560 "../src/game.vala"
	result = FALSE;
#line 560 "../src/game.vala"
	return result;
#line 2837 "game.c"
}

static ObjectType
__lambda24_ (Game* self,
             ObjectType obj)
{
	ObjectType result;
#line 565 "../src/game.vala"
	if (obj != OBJECT_TYPE_PLAYER) {
#line 566 "../src/game.vala"
		result = obj;
#line 566 "../src/game.vala"
		return result;
#line 2851 "game.c"
	} else {
#line 568 "../src/game.vala"
		result = OBJECT_TYPE_NONE;
#line 568 "../src/game.vala"
		return result;
#line 2857 "game.c"
	}
}

static ObjectType
___lambda24__arena_mapper (ObjectType obj,
                           gpointer self)
{
	ObjectType result;
	result = __lambda24_ ((Game*) self, obj);
#line 564 "../src/game.vala"
	return result;
#line 2869 "game.c"
}

static void
game_move_player_to (Game* self,
                     ArenaCoords* coords,
                     GameArenaChange* result)
{
	Arena* new_arena = NULL;
	Arena* _tmp0_;
	Arena* _tmp1_;
	Arena* _tmp2_;
	ArenaCoords _tmp3_;
	ArenaCoords _tmp4_;
	Arena* _tmp8_;
	Arena* _tmp9_;
	ArenaCoords _tmp10_;
	GameArenaChange _tmp11_ = {0};
#line 563 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 563 "../src/game.vala"
	g_return_if_fail (coords != NULL);
#line 564 "../src/game.vala"
	_tmp0_ = self->priv->_arena;
#line 564 "../src/game.vala"
	_tmp1_ = arena_map (_tmp0_, ___lambda24__arena_mapper, self);
#line 564 "../src/game.vala"
	new_arena = _tmp1_;
#line 571 "../src/game.vala"
	_tmp2_ = new_arena;
#line 571 "../src/game.vala"
	_tmp3_ = *coords;
#line 571 "../src/game.vala"
	_tmp4_ = *coords;
#line 571 "../src/game.vala"
	if (arena_get (_tmp2_, _tmp3_.x, _tmp4_.y) == OBJECT_TYPE_NONE) {
#line 2905 "game.c"
		Arena* _tmp5_;
		ArenaCoords _tmp6_;
		ArenaCoords _tmp7_;
#line 572 "../src/game.vala"
		_tmp5_ = new_arena;
#line 572 "../src/game.vala"
		_tmp6_ = *coords;
#line 572 "../src/game.vala"
		_tmp7_ = *coords;
#line 572 "../src/game.vala"
		arena_set (_tmp5_, _tmp6_.x, _tmp7_.y, OBJECT_TYPE_PLAYER);
#line 2917 "game.c"
	}
#line 574 "../src/game.vala"
	_tmp8_ = new_arena;
#line 574 "../src/game.vala"
	_tmp9_ = _arena_ref0 (_tmp8_);
#line 574 "../src/game.vala"
	_tmp10_ = *coords;
#line 574 "../src/game.vala"
	memset (&_tmp11_, 0, sizeof (GameArenaChange));
#line 574 "../src/game.vala"
	_arena_unref0 (_tmp11_.arena);
#line 574 "../src/game.vala"
	_tmp11_.arena = _tmp9_;
#line 574 "../src/game.vala"
	_tmp11_.player = _tmp10_;
#line 574 "../src/game.vala"
	_arena_coords_free0 (_tmp11_.push);
#line 574 "../src/game.vala"
	_tmp11_.push = NULL;
#line 574 "../src/game.vala"
	*result = _tmp11_;
#line 574 "../src/game.vala"
	_arena_unref0 (new_arena);
#line 574 "../src/game.vala"
	return;
#line 2943 "game.c"
}

/**
     * player_move
     * @dx: x direction
     * @dy: y direction
     *
     * Description:
     * moves the player in a given direction
     *
     * Returns:
     * TRUE if the player can move, FALSE otherwise
     **/
static gboolean
game_player_move (Game* self,
                  gint dx,
                  gint dy,
                  GameMoveSafety safety)
{
	GameArenaChange* change = NULL;
	GameArenaChange* _tmp0_;
	GameArenaChange* _tmp1_;
	GameArenaChange* _tmp5_;
	GameArenaChange _tmp6_;
	gboolean result;
#line 598 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 599 "../src/game.vala"
	_tmp0_ = game_try_player_move (self, dx, dy);
#line 599 "../src/game.vala"
	change = _tmp0_;
#line 601 "../src/game.vala"
	_tmp1_ = change;
#line 601 "../src/game.vala"
	if (_tmp1_ == NULL) {
#line 602 "../src/game.vala"
		result = FALSE;
#line 602 "../src/game.vala"
		_game_arena_change_free0 (change);
#line 602 "../src/game.vala"
		return result;
#line 2985 "game.c"
	}
#line 605 "../src/game.vala"
	if (safety != GAME_MOVE_SAFETY_UNSAFE) {
#line 2989 "game.c"
		GameArenaChange* _tmp2_;
		GameArenaChange _tmp3_;
#line 606 "../src/game.vala"
		_tmp2_ = change;
#line 606 "../src/game.vala"
		_tmp3_ = *_tmp2_;
#line 606 "../src/game.vala"
		if (!game_check_safe (self, &_tmp3_)) {
#line 2998 "game.c"
			gboolean _tmp4_ = FALSE;
#line 607 "../src/game.vala"
			if (safety == GAME_MOVE_SAFETY_SUPER_SAFE) {
#line 607 "../src/game.vala"
				_tmp4_ = TRUE;
#line 3004 "game.c"
			} else {
#line 607 "../src/game.vala"
				_tmp4_ = game_safe_move_available (self);
#line 3008 "game.c"
			}
#line 607 "../src/game.vala"
			if (_tmp4_) {
#line 608 "../src/game.vala"
				result = FALSE;
#line 608 "../src/game.vala"
				_game_arena_change_free0 (change);
#line 608 "../src/game.vala"
				return result;
#line 3018 "game.c"
			}
		}
	}
#line 613 "../src/game.vala"
	game_set_splat (self, NULL);
#line 614 "../src/game.vala"
	_tmp5_ = change;
#line 614 "../src/game.vala"
	_tmp6_ = *_tmp5_;
#line 614 "../src/game.vala"
	game_update_arena (self, &_tmp6_);
#line 616 "../src/game.vala"
	result = TRUE;
#line 616 "../src/game.vala"
	_game_arena_change_free0 (change);
#line 616 "../src/game.vala"
	return result;
#line 3036 "game.c"
}

/**
     * random_teleport
     *
     * Description:
     * randomly teleports the player
     *
     * Returns:
     * TRUE if the player can be teleported, FALSE otherwise
     **/
static gboolean
game_random_teleport (Game* self)
{
	gint rand_x = 0;
	GRand* _tmp0_;
	Arena* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint rand_y = 0;
	GRand* _tmp4_;
	Arena* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gboolean result;
#line 628 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 629 "../src/game.vala"
	_tmp0_ = self->priv->rand;
#line 629 "../src/game.vala"
	_tmp1_ = self->priv->_arena;
#line 629 "../src/game.vala"
	_tmp2_ = arena_get_width (_tmp1_);
#line 629 "../src/game.vala"
	_tmp3_ = _tmp2_;
#line 629 "../src/game.vala"
	rand_x = (gint) g_rand_int_range (_tmp0_, (gint32) 0, (gint32) _tmp3_);
#line 630 "../src/game.vala"
	_tmp4_ = self->priv->rand;
#line 630 "../src/game.vala"
	_tmp5_ = self->priv->_arena;
#line 630 "../src/game.vala"
	_tmp6_ = arena_get_height (_tmp5_);
#line 630 "../src/game.vala"
	_tmp7_ = _tmp6_;
#line 630 "../src/game.vala"
	rand_y = (gint) g_rand_int_range (_tmp4_, (gint32) 0, (gint32) _tmp7_);
#line 3084 "game.c"
	{
		ArenaIterableIterator* _p_it = NULL;
		Arena* _tmp8_;
		ArenaIterable* _tmp9_;
		ArenaIterable* _tmp10_;
		ArenaIterableIterator* _tmp11_;
		ArenaIterableIterator* _tmp12_;
		ArenaCoords* p = NULL;
#line 631 "../src/game.vala"
		_tmp8_ = self->priv->_arena;
#line 631 "../src/game.vala"
		_tmp9_ = arena_iterate_from (_tmp8_, rand_x, rand_y);
#line 631 "../src/game.vala"
		_tmp10_ = _tmp9_;
#line 631 "../src/game.vala"
		_tmp11_ = arena_iterable_iterator (_tmp10_);
#line 631 "../src/game.vala"
		_tmp12_ = _tmp11_;
#line 631 "../src/game.vala"
		_arena_iterable_unref0 (_tmp10_);
#line 631 "../src/game.vala"
		_p_it = _tmp12_;
#line 631 "../src/game.vala"
		while (TRUE) {
#line 3109 "game.c"
			ArenaIterableIterator* _tmp13_;
			ArenaCoords* _tmp14_;
			ArenaCoords* _tmp15_;
			Arena* _tmp16_;
			ArenaCoords* _tmp17_;
			ArenaCoords* _tmp18_;
			GameArenaChange change = {0};
			ArenaCoords* _tmp19_;
			ArenaCoords _tmp20_;
			GameArenaChange _tmp21_ = {0};
			GameArenaChange _tmp22_;
#line 631 "../src/game.vala"
			_tmp13_ = _p_it;
#line 631 "../src/game.vala"
			_tmp14_ = arena_iterable_iterator_next_value (_tmp13_);
#line 631 "../src/game.vala"
			_arena_coords_free0 (p);
#line 631 "../src/game.vala"
			p = _tmp14_;
#line 631 "../src/game.vala"
			_tmp15_ = p;
#line 631 "../src/game.vala"
			if (!(_tmp15_ != NULL)) {
#line 631 "../src/game.vala"
				break;
#line 3135 "game.c"
			}
#line 632 "../src/game.vala"
			_tmp16_ = self->priv->_arena;
#line 632 "../src/game.vala"
			_tmp17_ = p;
#line 632 "../src/game.vala"
			_tmp18_ = p;
#line 632 "../src/game.vala"
			if (arena_get (_tmp16_, (*_tmp17_).x, (*_tmp18_).y) != OBJECT_TYPE_NONE) {
#line 633 "../src/game.vala"
				continue;
#line 3147 "game.c"
			}
#line 636 "../src/game.vala"
			_tmp19_ = p;
#line 636 "../src/game.vala"
			_tmp20_ = *_tmp19_;
#line 636 "../src/game.vala"
			game_move_player_to (self, &_tmp20_, &_tmp21_);
#line 636 "../src/game.vala"
			change = _tmp21_;
#line 638 "../src/game.vala"
			_tmp22_ = change;
#line 638 "../src/game.vala"
			game_update_arena (self, &_tmp22_);
#line 639 "../src/game.vala"
			game_set_splat (self, NULL);
#line 640 "../src/game.vala"
			g_signal_emit (self, game_signals[GAME_GAME_EVENT_SIGNAL], 0, GAME_EVENT_TELEPORTED, 0);
#line 641 "../src/game.vala"
			result = TRUE;
#line 641 "../src/game.vala"
			game_arena_change_destroy (&change);
#line 641 "../src/game.vala"
			_arena_coords_free0 (p);
#line 641 "../src/game.vala"
			_arena_iterable_iterator_unref0 (_p_it);
#line 641 "../src/game.vala"
			return result;
#line 3175 "game.c"
		}
#line 631 "../src/game.vala"
		_arena_coords_free0 (p);
#line 631 "../src/game.vala"
		_arena_iterable_iterator_unref0 (_p_it);
#line 3181 "game.c"
	}
#line 645 "../src/game.vala"
	g_signal_emit (self, game_signals[GAME_GAME_EVENT_SIGNAL], 0, GAME_EVENT_NO_TELEPORT_LOCATIONS, 0);
#line 646 "../src/game.vala"
	result = FALSE;
#line 646 "../src/game.vala"
	return result;
#line 3189 "game.c"
}

/**
     * safe_teleport
     *
     * Description:
     * teleports the player to safe location
     *
     * Returns:
     * TRUE if player can be teleported, FALSE otherwise
     **/
static gboolean
game_safe_teleport (Game* self)
{
	gint rand_x = 0;
	GRand* _tmp0_;
	Arena* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint rand_y = 0;
	GRand* _tmp4_;
	Arena* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gboolean result;
#line 658 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 659 "../src/game.vala"
	if (self->priv->safe_teleports <= 0) {
#line 660 "../src/game.vala"
		result = FALSE;
#line 660 "../src/game.vala"
		return result;
#line 3223 "game.c"
	}
#line 663 "../src/game.vala"
	_tmp0_ = self->priv->rand;
#line 663 "../src/game.vala"
	_tmp1_ = self->priv->_arena;
#line 663 "../src/game.vala"
	_tmp2_ = arena_get_width (_tmp1_);
#line 663 "../src/game.vala"
	_tmp3_ = _tmp2_;
#line 663 "../src/game.vala"
	rand_x = (gint) g_rand_int_range (_tmp0_, (gint32) 0, (gint32) _tmp3_);
#line 664 "../src/game.vala"
	_tmp4_ = self->priv->rand;
#line 664 "../src/game.vala"
	_tmp5_ = self->priv->_arena;
#line 664 "../src/game.vala"
	_tmp6_ = arena_get_height (_tmp5_);
#line 664 "../src/game.vala"
	_tmp7_ = _tmp6_;
#line 664 "../src/game.vala"
	rand_y = (gint) g_rand_int_range (_tmp4_, (gint32) 0, (gint32) _tmp7_);
#line 3245 "game.c"
	{
		ArenaIterableIterator* _p_it = NULL;
		Arena* _tmp8_;
		ArenaIterable* _tmp9_;
		ArenaIterable* _tmp10_;
		ArenaIterableIterator* _tmp11_;
		ArenaIterableIterator* _tmp12_;
		ArenaCoords* p = NULL;
#line 665 "../src/game.vala"
		_tmp8_ = self->priv->_arena;
#line 665 "../src/game.vala"
		_tmp9_ = arena_iterate_from (_tmp8_, rand_x, rand_y);
#line 665 "../src/game.vala"
		_tmp10_ = _tmp9_;
#line 665 "../src/game.vala"
		_tmp11_ = arena_iterable_iterator (_tmp10_);
#line 665 "../src/game.vala"
		_tmp12_ = _tmp11_;
#line 665 "../src/game.vala"
		_arena_iterable_unref0 (_tmp10_);
#line 665 "../src/game.vala"
		_p_it = _tmp12_;
#line 665 "../src/game.vala"
		while (TRUE) {
#line 3270 "game.c"
			ArenaIterableIterator* _tmp13_;
			ArenaCoords* _tmp14_;
			ArenaCoords* _tmp15_;
			Arena* _tmp16_;
			ArenaCoords* _tmp17_;
			ArenaCoords* _tmp18_;
			GameArenaChange change = {0};
			ArenaCoords* _tmp19_;
			ArenaCoords _tmp20_;
			GameArenaChange _tmp21_ = {0};
			GameArenaChange _tmp22_;
			GameArenaChange _tmp23_;
#line 665 "../src/game.vala"
			_tmp13_ = _p_it;
#line 665 "../src/game.vala"
			_tmp14_ = arena_iterable_iterator_next_value (_tmp13_);
#line 665 "../src/game.vala"
			_arena_coords_free0 (p);
#line 665 "../src/game.vala"
			p = _tmp14_;
#line 665 "../src/game.vala"
			_tmp15_ = p;
#line 665 "../src/game.vala"
			if (!(_tmp15_ != NULL)) {
#line 665 "../src/game.vala"
				break;
#line 3297 "game.c"
			}
#line 666 "../src/game.vala"
			_tmp16_ = self->priv->_arena;
#line 666 "../src/game.vala"
			_tmp17_ = p;
#line 666 "../src/game.vala"
			_tmp18_ = p;
#line 666 "../src/game.vala"
			if (arena_get (_tmp16_, (*_tmp17_).x, (*_tmp18_).y) != OBJECT_TYPE_NONE) {
#line 667 "../src/game.vala"
				continue;
#line 3309 "game.c"
			}
#line 670 "../src/game.vala"
			_tmp19_ = p;
#line 670 "../src/game.vala"
			_tmp20_ = *_tmp19_;
#line 670 "../src/game.vala"
			game_move_player_to (self, &_tmp20_, &_tmp21_);
#line 670 "../src/game.vala"
			change = _tmp21_;
#line 671 "../src/game.vala"
			_tmp22_ = change;
#line 671 "../src/game.vala"
			if (!game_check_safe (self, &_tmp22_)) {
#line 672 "../src/game.vala"
				game_arena_change_destroy (&change);
#line 672 "../src/game.vala"
				continue;
#line 3327 "game.c"
			}
#line 675 "../src/game.vala"
			self->priv->safe_teleports = self->priv->safe_teleports - 1;
#line 677 "../src/game.vala"
			_tmp23_ = change;
#line 677 "../src/game.vala"
			game_update_arena (self, &_tmp23_);
#line 678 "../src/game.vala"
			game_set_splat (self, NULL);
#line 679 "../src/game.vala"
			g_signal_emit (self, game_signals[GAME_GAME_EVENT_SIGNAL], 0, GAME_EVENT_TELEPORTED, 0);
#line 681 "../src/game.vala"
			result = TRUE;
#line 681 "../src/game.vala"
			game_arena_change_destroy (&change);
#line 681 "../src/game.vala"
			_arena_coords_free0 (p);
#line 681 "../src/game.vala"
			_arena_iterable_iterator_unref0 (_p_it);
#line 681 "../src/game.vala"
			return result;
#line 3349 "game.c"
		}
#line 665 "../src/game.vala"
		_arena_coords_free0 (p);
#line 665 "../src/game.vala"
		_arena_iterable_iterator_unref0 (_p_it);
#line 3355 "game.c"
	}
#line 684 "../src/game.vala"
	g_signal_emit (self, game_signals[GAME_GAME_EVENT_SIGNAL], 0, GAME_EVENT_NO_SAFE_TELEPORT_LOCATIONS, 0);
#line 685 "../src/game.vala"
	game_kill_player (self);
#line 686 "../src/game.vala"
	result = FALSE;
#line 686 "../src/game.vala"
	return result;
#line 3365 "game.c"
}

/**
     * handles player's commands
     **/
gboolean
game_player_command (Game* self,
                     PlayerCommand cmd,
                     GameMoveSafety safety)
{
	GameState _tmp0_;
	gboolean result;
#line 692 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 695 "../src/game.vala"
	_tmp0_ = self->priv->_state;
#line 695 "../src/game.vala"
	if (_tmp0_ != GAME_STATE_PLAYING) {
#line 696 "../src/game.vala"
		result = FALSE;
#line 696 "../src/game.vala"
		return result;
#line 3388 "game.c"
	}
#line 698 "../src/game.vala"
	switch (cmd) {
#line 698 "../src/game.vala"
		case PLAYER_COMMAND_NW:
#line 698 "../src/game.vala"
		case PLAYER_COMMAND_N:
#line 698 "../src/game.vala"
		case PLAYER_COMMAND_NE:
#line 698 "../src/game.vala"
		case PLAYER_COMMAND_W:
#line 698 "../src/game.vala"
		case PLAYER_COMMAND_STAY:
#line 698 "../src/game.vala"
		case PLAYER_COMMAND_E:
#line 698 "../src/game.vala"
		case PLAYER_COMMAND_SW:
#line 698 "../src/game.vala"
		case PLAYER_COMMAND_S:
#line 698 "../src/game.vala"
		case PLAYER_COMMAND_SE:
#line 3410 "game.c"
		{
			gint dx = 0;
			gint dy = 0;
			gint _tmp1_ = 0;
			gint _tmp2_ = 0;
			gboolean _tmp3_;
#line 709 "../src/game.vala"
			_tmp3_ = player_command_to_direction (cmd, &_tmp1_, &_tmp2_);
#line 709 "../src/game.vala"
			dx = _tmp1_;
#line 709 "../src/game.vala"
			dy = _tmp2_;
#line 709 "../src/game.vala"
			_vala_assert (_tmp3_, "cmd.to_direction (out dx, out dy)");
#line 710 "../src/game.vala"
			if (game_player_move (self, dx, dy, safety)) {
#line 711 "../src/game.vala"
				game_move_robots (self);
#line 712 "../src/game.vala"
				result = TRUE;
#line 712 "../src/game.vala"
				return result;
#line 3433 "game.c"
			} else {
#line 714 "../src/game.vala"
				result = FALSE;
#line 714 "../src/game.vala"
				return result;
#line 3439 "game.c"
			}
		}
#line 698 "../src/game.vala"
		case PLAYER_COMMAND_SAFE_TELEPORT:
#line 3444 "game.c"
		{
#line 717 "../src/game.vala"
			if (game_safe_teleport (self)) {
#line 718 "../src/game.vala"
				game_move_robots (self);
#line 3450 "game.c"
			}
#line 720 "../src/game.vala"
			result = TRUE;
#line 720 "../src/game.vala"
			return result;
#line 3456 "game.c"
		}
#line 698 "../src/game.vala"
		case PLAYER_COMMAND_RANDOM_TELEPORT:
#line 3460 "game.c"
		{
#line 722 "../src/game.vala"
			if (game_random_teleport (self)) {
#line 723 "../src/game.vala"
				game_move_robots (self);
#line 3466 "game.c"
			}
#line 725 "../src/game.vala"
			result = TRUE;
#line 725 "../src/game.vala"
			return result;
#line 3472 "game.c"
		}
#line 698 "../src/game.vala"
		case PLAYER_COMMAND_WAIT:
#line 3476 "game.c"
		{
#line 727 "../src/game.vala"
			game_set_state (self, GAME_STATE_WAITING);
#line 728 "../src/game.vala"
			result = TRUE;
#line 728 "../src/game.vala"
			return result;
#line 3484 "game.c"
		}
		default:
		{
#line 730 "../src/game.vala"
			result = FALSE;
#line 730 "../src/game.vala"
			return result;
#line 3492 "game.c"
		}
	}
}

GameState
game_get_state (Game* self)
{
	GameState result;
#line 101 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 101 "../src/game.vala"
	result = self->priv->_state;
#line 101 "../src/game.vala"
	return result;
#line 3507 "game.c"
}

static void
game_set_state (Game* self,
                GameState value)
{
#line 101 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 101 "../src/game.vala"
	self->priv->_state = value;
#line 3518 "game.c"
}

Arena*
game_get_arena (Game* self)
{
	Arena* result;
	Arena* _tmp0_;
#line 102 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 102 "../src/game.vala"
	_tmp0_ = self->priv->_arena;
#line 102 "../src/game.vala"
	result = _tmp0_;
#line 102 "../src/game.vala"
	return result;
#line 3534 "game.c"
}

static void
game_set_arena (Game* self,
                Arena* value)
{
	Arena* _tmp0_;
#line 102 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 102 "../src/game.vala"
	_tmp0_ = _arena_ref0 (value);
#line 102 "../src/game.vala"
	_arena_unref0 (self->priv->_arena);
#line 102 "../src/game.vala"
	self->priv->_arena = _tmp0_;
#line 3550 "game.c"
}

void
game_get_config (Game* self,
                 GameConfig * result)
{
	GameConfig _tmp0_;
#line 103 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 103 "../src/game.vala"
	_tmp0_ = self->priv->_config;
#line 103 "../src/game.vala"
	*result = _tmp0_;
#line 103 "../src/game.vala"
	return;
#line 3566 "game.c"
}

void
game_set_config (Game* self,
                 GameConfig * value)
{
	GameConfig _tmp0_;
	GameConfig _tmp1_;
	GameConfig _tmp2_ = {0};
#line 103 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 103 "../src/game.vala"
	_tmp0_ = *value;
#line 103 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 103 "../src/game.vala"
	game_config_copy (&_tmp1_, &_tmp2_);
#line 103 "../src/game.vala"
	game_config_destroy (&self->priv->_config);
#line 103 "../src/game.vala"
	self->priv->_config = _tmp2_;
#line 3588 "game.c"
}

gint
game_get_width (Game* self)
{
	gint result;
	Arena* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 105 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 105 "../src/game.vala"
	_tmp0_ = self->priv->_arena;
#line 105 "../src/game.vala"
	_tmp1_ = arena_get_width (_tmp0_);
#line 105 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 105 "../src/game.vala"
	result = _tmp2_;
#line 105 "../src/game.vala"
	return result;
#line 3610 "game.c"
}

gint
game_get_height (Game* self)
{
	gint result;
	Arena* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 108 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 108 "../src/game.vala"
	_tmp0_ = self->priv->_arena;
#line 108 "../src/game.vala"
	_tmp1_ = arena_get_height (_tmp0_);
#line 108 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 108 "../src/game.vala"
	result = _tmp2_;
#line 108 "../src/game.vala"
	return result;
#line 3632 "game.c"
}

void
game_get_player (Game* self,
                 ArenaCoords * result)
{
	ArenaCoords _tmp0_;
#line 110 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 110 "../src/game.vala"
	_tmp0_ = self->priv->_player;
#line 110 "../src/game.vala"
	*result = _tmp0_;
#line 110 "../src/game.vala"
	return;
#line 3648 "game.c"
}

static void
game_set_player (Game* self,
                 ArenaCoords * value)
{
	ArenaCoords _tmp0_;
#line 110 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 110 "../src/game.vala"
	_tmp0_ = *value;
#line 110 "../src/game.vala"
	self->priv->_player = _tmp0_;
#line 3662 "game.c"
}

ArenaCoords*
game_get_splat (Game* self)
{
	ArenaCoords* result;
	ArenaCoords* _tmp0_;
#line 111 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 111 "../src/game.vala"
	_tmp0_ = self->priv->_splat;
#line 111 "../src/game.vala"
	result = _tmp0_;
#line 111 "../src/game.vala"
	return result;
#line 3678 "game.c"
}

static void
game_set_splat (Game* self,
                ArenaCoords* value)
{
	ArenaCoords* _tmp0_;
#line 111 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 111 "../src/game.vala"
	_tmp0_ = _arena_coords_dup0 (value);
#line 111 "../src/game.vala"
	_arena_coords_free0 (self->priv->_splat);
#line 111 "../src/game.vala"
	self->priv->_splat = _tmp0_;
#line 3694 "game.c"
}

void
game_get_status (Game* self,
                 GameStatus * result)
{
	GameStatus _tmp0_ = {0};
#line 122 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 123 "../src/game.vala"
	memset (&_tmp0_, 0, sizeof (GameStatus));
#line 123 "../src/game.vala"
	_tmp0_.score = self->priv->score;
#line 123 "../src/game.vala"
	_tmp0_.current_level = self->priv->current_level + 1;
#line 123 "../src/game.vala"
	_tmp0_.safe_teleports = self->priv->safe_teleports;
#line 123 "../src/game.vala"
	*result = _tmp0_;
#line 123 "../src/game.vala"
	return;
#line 3716 "game.c"
}

static void
g_cclosure_user_marshal_VOID__ENUM_INT (GClosure * closure,
                                        GValue * return_value,
                                        guint n_param_values,
                                        const GValue * param_values,
                                        gpointer invocation_hint,
                                        gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__ENUM_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__ENUM_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 75 "../src/game.vala"
	g_return_if_fail (n_param_values == 3);
#line 75 "../src/game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 75 "../src/game.vala"
		data1 = closure->data;
#line 75 "../src/game.vala"
		data2 = param_values->data[0].v_pointer;
#line 3741 "game.c"
	} else {
#line 75 "../src/game.vala"
		data1 = param_values->data[0].v_pointer;
#line 75 "../src/game.vala"
		data2 = closure->data;
#line 3747 "game.c"
	}
#line 75 "../src/game.vala"
	callback = (GMarshalFunc_VOID__ENUM_INT) (marshal_data ? marshal_data : cc->callback);
#line 75 "../src/game.vala"
	callback (data1, g_value_get_enum (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 3753 "game.c"
}

GameStatus*
game_status_dup (const GameStatus* self)
{
	GameStatus* dup;
#line 86 "../src/game.vala"
	dup = g_new0 (GameStatus, 1);
#line 86 "../src/game.vala"
	memcpy (dup, self, sizeof (GameStatus));
#line 86 "../src/game.vala"
	return dup;
#line 3766 "game.c"
}

void
game_status_free (GameStatus* self)
{
#line 86 "../src/game.vala"
	g_free (self);
#line 3774 "game.c"
}

static GType
game_status_get_type_once (void)
{
	GType game_status_type_id;
	game_status_type_id = g_boxed_type_register_static ("GameStatus", (GBoxedCopyFunc) game_status_dup, (GBoxedFreeFunc) game_status_free);
	return game_status_type_id;
}

GType
game_status_get_type (void)
{
	static volatile gsize game_status_type_id__once = 0;
	if (g_once_init_enter (&game_status_type_id__once)) {
		GType game_status_type_id;
		game_status_type_id = game_status_get_type_once ();
		g_once_init_leave (&game_status_type_id__once, game_status_type_id);
	}
	return game_status_type_id__once;
}

static void
game_arena_change_copy (const GameArenaChange* self,
                        GameArenaChange* dest)
{
	Arena* _tmp0_;
	Arena* _tmp1_;
	ArenaCoords _tmp2_;
	ArenaCoords* _tmp3_;
	ArenaCoords* _tmp4_;
#line 131 "../src/game.vala"
	_tmp0_ = (*self).arena;
#line 131 "../src/game.vala"
	_tmp1_ = _arena_ref0 (_tmp0_);
#line 131 "../src/game.vala"
	_arena_unref0 ((*dest).arena);
#line 131 "../src/game.vala"
	(*dest).arena = _tmp1_;
#line 131 "../src/game.vala"
	_tmp2_ = (*self).player;
#line 131 "../src/game.vala"
	(*dest).player = _tmp2_;
#line 131 "../src/game.vala"
	_tmp3_ = (*self).push;
#line 131 "../src/game.vala"
	_tmp4_ = _arena_coords_dup0 (_tmp3_);
#line 131 "../src/game.vala"
	_arena_coords_free0 ((*dest).push);
#line 131 "../src/game.vala"
	(*dest).push = _tmp4_;
#line 3826 "game.c"
}

static void
game_arena_change_destroy (GameArenaChange* self)
{
#line 132 "../src/game.vala"
	_arena_unref0 ((*self).arena);
#line 134 "../src/game.vala"
	_arena_coords_free0 ((*self).push);
#line 3836 "game.c"
}

static GameArenaChange*
game_arena_change_dup (const GameArenaChange* self)
{
	GameArenaChange* dup;
#line 131 "../src/game.vala"
	dup = g_new0 (GameArenaChange, 1);
#line 131 "../src/game.vala"
	game_arena_change_copy (self, dup);
#line 131 "../src/game.vala"
	return dup;
#line 3849 "game.c"
}

static void
game_arena_change_free (GameArenaChange* self)
{
#line 131 "../src/game.vala"
	game_arena_change_destroy (self);
#line 131 "../src/game.vala"
	g_free (self);
#line 3859 "game.c"
}

static GType
game_arena_change_get_type_once (void)
{
	GType game_arena_change_type_id;
	game_arena_change_type_id = g_boxed_type_register_static ("GameArenaChange", (GBoxedCopyFunc) game_arena_change_dup, (GBoxedFreeFunc) game_arena_change_free);
	return game_arena_change_type_id;
}

static GType
game_arena_change_get_type (void)
{
	static volatile gsize game_arena_change_type_id__once = 0;
	if (g_once_init_enter (&game_arena_change_type_id__once)) {
		GType game_arena_change_type_id;
		game_arena_change_type_id = game_arena_change_get_type_once ();
		g_once_init_leave (&game_arena_change_type_id__once, game_arena_change_type_id);
	}
	return game_arena_change_type_id__once;
}

static void
value_game_init (GValue* value)
{
#line 75 "../src/game.vala"
	value->data[0].v_pointer = NULL;
#line 3887 "game.c"
}

static void
value_game_free_value (GValue* value)
{
#line 75 "../src/game.vala"
	if (value->data[0].v_pointer) {
#line 75 "../src/game.vala"
		game_unref (value->data[0].v_pointer);
#line 3897 "game.c"
	}
}

static void
value_game_copy_value (const GValue* src_value,
                       GValue* dest_value)
{
#line 75 "../src/game.vala"
	if (src_value->data[0].v_pointer) {
#line 75 "../src/game.vala"
		dest_value->data[0].v_pointer = game_ref (src_value->data[0].v_pointer);
#line 3909 "game.c"
	} else {
#line 75 "../src/game.vala"
		dest_value->data[0].v_pointer = NULL;
#line 3913 "game.c"
	}
}

static gpointer
value_game_peek_pointer (const GValue* value)
{
#line 75 "../src/game.vala"
	return value->data[0].v_pointer;
#line 3922 "game.c"
}

static gchar*
value_game_collect_value (GValue* value,
                          guint n_collect_values,
                          GTypeCValue* collect_values,
                          guint collect_flags)
{
#line 75 "../src/game.vala"
	if (collect_values[0].v_pointer) {
#line 3933 "game.c"
		Game * object;
		object = collect_values[0].v_pointer;
#line 75 "../src/game.vala"
		if (object->parent_instance.g_class == NULL) {
#line 75 "../src/game.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3940 "game.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 75 "../src/game.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3944 "game.c"
		}
#line 75 "../src/game.vala"
		value->data[0].v_pointer = game_ref (object);
#line 3948 "game.c"
	} else {
#line 75 "../src/game.vala"
		value->data[0].v_pointer = NULL;
#line 3952 "game.c"
	}
#line 75 "../src/game.vala"
	return NULL;
#line 3956 "game.c"
}

static gchar*
value_game_lcopy_value (const GValue* value,
                        guint n_collect_values,
                        GTypeCValue* collect_values,
                        guint collect_flags)
{
	Game ** object_p;
	object_p = collect_values[0].v_pointer;
#line 75 "../src/game.vala"
	if (!object_p) {
#line 75 "../src/game.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 3971 "game.c"
	}
#line 75 "../src/game.vala"
	if (!value->data[0].v_pointer) {
#line 75 "../src/game.vala"
		*object_p = NULL;
#line 3977 "game.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 75 "../src/game.vala"
		*object_p = value->data[0].v_pointer;
#line 3981 "game.c"
	} else {
#line 75 "../src/game.vala"
		*object_p = game_ref (value->data[0].v_pointer);
#line 3985 "game.c"
	}
#line 75 "../src/game.vala"
	return NULL;
#line 3989 "game.c"
}

GParamSpec*
param_spec_game (const gchar* name,
                 const gchar* nick,
                 const gchar* blurb,
                 GType object_type,
                 GParamFlags flags)
{
	ParamSpecGame* spec;
#line 75 "../src/game.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_GAME), NULL);
#line 75 "../src/game.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 75 "../src/game.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 75 "../src/game.vala"
	return G_PARAM_SPEC (spec);
#line 4008 "game.c"
}

gpointer
value_get_game (const GValue* value)
{
#line 75 "../src/game.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_GAME), NULL);
#line 75 "../src/game.vala"
	return value->data[0].v_pointer;
#line 4018 "game.c"
}

void
value_set_game (GValue* value,
                gpointer v_object)
{
	Game * old;
#line 75 "../src/game.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_GAME));
#line 75 "../src/game.vala"
	old = value->data[0].v_pointer;
#line 75 "../src/game.vala"
	if (v_object) {
#line 75 "../src/game.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_GAME));
#line 75 "../src/game.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 75 "../src/game.vala"
		value->data[0].v_pointer = v_object;
#line 75 "../src/game.vala"
		game_ref (value->data[0].v_pointer);
#line 4040 "game.c"
	} else {
#line 75 "../src/game.vala"
		value->data[0].v_pointer = NULL;
#line 4044 "game.c"
	}
#line 75 "../src/game.vala"
	if (old) {
#line 75 "../src/game.vala"
		game_unref (old);
#line 4050 "game.c"
	}
}

void
value_take_game (GValue* value,
                 gpointer v_object)
{
	Game * old;
#line 75 "../src/game.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_GAME));
#line 75 "../src/game.vala"
	old = value->data[0].v_pointer;
#line 75 "../src/game.vala"
	if (v_object) {
#line 75 "../src/game.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_GAME));
#line 75 "../src/game.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 75 "../src/game.vala"
		value->data[0].v_pointer = v_object;
#line 4071 "game.c"
	} else {
#line 75 "../src/game.vala"
		value->data[0].v_pointer = NULL;
#line 4075 "game.c"
	}
#line 75 "../src/game.vala"
	if (old) {
#line 75 "../src/game.vala"
		game_unref (old);
#line 4081 "game.c"
	}
}

static void
game_class_init (GameClass * klass,
                 gpointer klass_data)
{
#line 75 "../src/game.vala"
	game_parent_class = g_type_class_peek_parent (klass);
#line 75 "../src/game.vala"
	((GameClass *) klass)->finalize = game_finalize;
#line 75 "../src/game.vala"
	g_type_class_adjust_private_offset (klass, &Game_private_offset);
#line 75 "../src/game.vala"
	game_signals[GAME_GAME_EVENT_SIGNAL] = g_signal_new ("game-event", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__ENUM_INT, G_TYPE_NONE, 2, GAME_TYPE_EVENT, G_TYPE_INT);
#line 4097 "game.c"
}

static void
game_instance_init (Game * self,
                    gpointer klass)
{
#line 75 "../src/game.vala"
	self->priv = game_get_instance_private (self);
#line 114 "../src/game.vala"
	self->priv->endlev_counter = 0;
#line 115 "../src/game.vala"
	self->priv->current_level = 0;
#line 116 "../src/game.vala"
	self->priv->score = 0;
#line 117 "../src/game.vala"
	self->priv->kills = 0;
#line 118 "../src/game.vala"
	self->priv->score_step = 0;
#line 119 "../src/game.vala"
	self->priv->safe_teleports = 0;
#line 75 "../src/game.vala"
	self->ref_count = 1;
#line 4120 "game.c"
}

static void
game_finalize (Game * obj)
{
	Game * self;
#line 75 "../src/game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME, Game);
#line 75 "../src/game.vala"
	g_signal_handlers_destroy (self);
#line 102 "../src/game.vala"
	_arena_unref0 (self->priv->_arena);
#line 103 "../src/game.vala"
	game_config_destroy (&self->priv->_config);
#line 111 "../src/game.vala"
	_arena_coords_free0 (self->priv->_splat);
#line 113 "../src/game.vala"
	_g_rand_free0 (self->priv->rand);
#line 4139 "game.c"
}

static GType
game_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_game_init, value_game_free_value, value_game_copy_value, value_game_peek_pointer, "p", value_game_collect_value, "p", value_game_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Game), 0, (GInstanceInitFunc) game_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType game_type_id;
	game_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Game", &g_define_type_info, &g_define_type_fundamental_info, 0);
	Game_private_offset = g_type_add_instance_private (game_type_id, sizeof (GamePrivate));
	return game_type_id;
}

GType
game_get_type (void)
{
	static volatile gsize game_type_id__once = 0;
	if (g_once_init_enter (&game_type_id__once)) {
		GType game_type_id;
		game_type_id = game_get_type_once ();
		g_once_init_leave (&game_type_id__once, game_type_id);
	}
	return game_type_id__once;
}

gpointer
game_ref (gpointer instance)
{
	Game * self;
	self = instance;
#line 75 "../src/game.vala"
	g_atomic_int_inc (&self->ref_count);
#line 75 "../src/game.vala"
	return instance;
#line 4175 "game.c"
}

void
game_unref (gpointer instance)
{
	Game * self;
	self = instance;
#line 75 "../src/game.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 75 "../src/game.vala"
		GAME_GET_CLASS (self)->finalize (self);
#line 75 "../src/game.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 4189 "game.c"
	}
}

