/* graphics.c generated by valac 0.56.17, the Vala compiler
 * generated from graphics.vala, do not modify */

/*
 * Copyright 2020 Andrey Kutejko <andy128k@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 * For more details see the file COPYING.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

VALA_EXTERN void string_to_rgba (const gchar* color,
                     GdkRGBA* result);
VALA_EXTERN gchar* rgba_to_string (GdkRGBA* color);
VALA_EXTERN void calculate_light_color (GdkRGBA* color,
                            GdkRGBA* result);

void
string_to_rgba (const gchar* color,
                GdkRGBA* result)
{
	GdkRGBA rgba = {0};
#line 23 "../src/graphics.vala"
	g_return_if_fail (color != NULL);
#line 24 "../src/graphics.vala"
	memset (&rgba, 0, sizeof (GdkRGBA));
#line 25 "../src/graphics.vala"
	gdk_rgba_parse (&rgba, color);
#line 26 "../src/graphics.vala"
	*result = rgba;
#line 26 "../src/graphics.vala"
	return;
#line 70 "graphics.c"
}

gchar*
rgba_to_string (GdkRGBA* color)
{
	GdkRGBA _tmp0_;
	GdkRGBA _tmp1_;
	GdkRGBA _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 29 "../src/graphics.vala"
	g_return_val_if_fail (color != NULL, NULL);
#line 30 "../src/graphics.vala"
	_tmp0_ = *color;
#line 30 "../src/graphics.vala"
	_tmp1_ = *color;
#line 30 "../src/graphics.vala"
	_tmp2_ = *color;
#line 30 "../src/graphics.vala"
	_tmp3_ = g_strdup_printf ("#%04x%04x%04x", (guint) ((gint) ((_tmp0_.red * 65535) + 0.5)), (guint) ((gint) ((_tmp1_.green * 65535) + 0.5)), (guint) ((gint) ((_tmp2_.blue * 65535) + 0.5)));
#line 30 "../src/graphics.vala"
	result = _tmp3_;
#line 30 "../src/graphics.vala"
	return result;
#line 95 "graphics.c"
}

void
calculate_light_color (GdkRGBA* color,
                       GdkRGBA* result)
{
	GdkRGBA light = {0};
	gdouble brightness = 0.0;
	GdkRGBA _tmp0_;
	GdkRGBA _tmp1_;
	GdkRGBA _tmp2_;
#line 36 "../src/graphics.vala"
	g_return_if_fail (color != NULL);
#line 40 "../src/graphics.vala"
	memset (&light, 0, sizeof (GdkRGBA));
#line 41 "../src/graphics.vala"
	_tmp0_ = *color;
#line 41 "../src/graphics.vala"
	_tmp1_ = *color;
#line 41 "../src/graphics.vala"
	_tmp2_ = *color;
#line 41 "../src/graphics.vala"
	brightness = (_tmp0_.red + _tmp1_.green) + _tmp2_.blue;
#line 42 "../src/graphics.vala"
	if (brightness > (1.0 / 1.1)) {
#line 121 "graphics.c"
		GdkRGBA _tmp3_;
		GdkRGBA _tmp4_;
		GdkRGBA _tmp5_;
#line 44 "../src/graphics.vala"
		_tmp3_ = *color;
#line 44 "../src/graphics.vala"
		light.red = 0.9 * _tmp3_.red;
#line 45 "../src/graphics.vala"
		_tmp4_ = *color;
#line 45 "../src/graphics.vala"
		light.green = 0.9 * _tmp4_.green;
#line 46 "../src/graphics.vala"
		_tmp5_ = *color;
#line 46 "../src/graphics.vala"
		light.blue = 0.9 * _tmp5_.blue;
#line 137 "graphics.c"
	} else {
#line 47 "../src/graphics.vala"
		if (brightness > 0.04) {
#line 141 "graphics.c"
			GdkRGBA _tmp6_;
			GdkRGBA _tmp7_;
			GdkRGBA _tmp8_;
#line 49 "../src/graphics.vala"
			_tmp6_ = *color;
#line 49 "../src/graphics.vala"
			light.red = 1.1 * _tmp6_.red;
#line 50 "../src/graphics.vala"
			_tmp7_ = *color;
#line 50 "../src/graphics.vala"
			light.green = 1.1 * _tmp7_.green;
#line 51 "../src/graphics.vala"
			_tmp8_ = *color;
#line 51 "../src/graphics.vala"
			light.blue = 1.1 * _tmp8_.blue;
#line 157 "graphics.c"
		} else {
			GdkRGBA _tmp9_;
			GdkRGBA _tmp10_;
			GdkRGBA _tmp11_;
#line 54 "../src/graphics.vala"
			_tmp9_ = *color;
#line 54 "../src/graphics.vala"
			light.red = 0.04 + _tmp9_.red;
#line 55 "../src/graphics.vala"
			_tmp10_ = *color;
#line 55 "../src/graphics.vala"
			light.green = 0.04 + _tmp10_.green;
#line 56 "../src/graphics.vala"
			_tmp11_ = *color;
#line 56 "../src/graphics.vala"
			light.blue = 0.04 + _tmp11_.blue;
#line 174 "graphics.c"
		}
	}
#line 58 "../src/graphics.vala"
	light.alpha = 1.0;
#line 59 "../src/graphics.vala"
	*result = light;
#line 59 "../src/graphics.vala"
	return;
#line 183 "graphics.c"
}

